DECLARE SUB svgacheckmode (x%, md&)

DECLARE SUB SVGAPutBlockBW (xi%, yi%, dx%, dy%)
DECLARE SUB SVGAPutBlock (xi%, yi%, dx%, dy%)
DECLARE FUNCTION JPEGRenderColor% (jfile%, x0%, y0%)
DECLARE FUNCTION JPEGRenderMono% (jfile%, x0%, y0%)
DECLARE FUNCTION JpegRenderColor2% (jfile%, x0%, y0%)
DECLARE FUNCTION JPEGRender2% (jfile%, x0%, y0%)
DECLARE SUB JPEGRenderpixel ()
'JPEG VIEWER 4.1  by Antoni Gual    agual@eic.ictnet.es
'commented version 20-Nov-03
'----------------------------------------------------------------------------
'to do:
'ok A Serious error handler
'ok Simplify JPEGRenderColor
'ok Deal with images 2x1 AND 1x2
'ok Set a mcu array that can be put into screen in 1 SVGA call
'ok Remove SVGA bank setting from JPEGRenderColor
'   Back to a milder SVGA library, not setting line lengths (It breaks some cards)
'    (could use TCLib's) ADD BACK 24 BIT MODE
'ok Add granularity to SVGA
'SUB DECLARES----------------------------------------------------------------

'SVGA routines. Putpixel is implemented inline for speed

'prints scaled text
DECLARE SUB SVGAPRINT (t$, xstartpos%, ystartpos%, scrxsize%, scrysize%, chspacing%, font%)
'gets info for a mode
DECLARE SUB SVGAGetModeInfo (md&)
'Inits SVGA , gets general SVGA info and the ROM font afddress
DECLARE SUB SVGAInit ()
'sets a mode, inits all LUT tables involved
DECLARE FUNCTION SVGAsetmode% (MODE%)

'File selector routines

'Detects windows and the temp dir
DECLARE SUB DetectWinTemp ()
'saves program dir
DECLARE FUNCTION getcurdir$ (save%)
'checks if disk is ready
DECLARE FUNCTION DiskReady% (d$)

'My poor user interface
'File Selector using scrolling list  TUI: Spaghetti!! Not commented
DECLARE FUNCTION SelectAFile$ (header$, ext$)
'Displays main menu
DECLARE SUB menu ()
'Gets data from SVGA modes and presents a menu allowing user to select mode
DECLARE FUNCTION SVGASelectMode% ()



'Gets the current JPEG parameters, tables and headers, skips comments and app data
DECLARE FUNCTION JPEGGetParms% (jfile%)
'displays current jpeg parameters
DECLARE SUB JPEGViewParms ()
'Huffman decompress,zigzag reorder,dequantize and IDCT transform a 8X8 block
DECLARE SUB JPEGGet8x8 (vector%(), comp%, dcCoef%)
'Gets a single byte from file. Buffered. Eliminates &hff &h00 pairs
DECLARE FUNCTION JPEGGetByte% ()
'Combines blocks an an mcu, converts Y-Cb-Cr to RGB and puts mcu to screen
DECLARE FUNCTION JPEGRender% (jfile%, x0%, y0%)
'Gets a big endian word from the file
DECLARE FUNCTION JPEGGetWord& ()
'read from file enough bits to index into Huffman tree and return a Huff code
DECLARE FUNCTION JPEGGetHuff% (hptr%)
'read n bits from file and "reverse" them as per Jpeg spec, if needed
DECLARE FUNCTION JPEGGetNBits% (nbits%)
'reads num bytes from file and return them in a string
DECLARE FUNCTION JPEGgetstr$ (num%)
'reads huffman tables from file and convert them into a binary tree
DECLARE SUB JPEGMakeHuffTree ()




'TYPES-------------------------------------------------------------------
'interrupt calls  for SVGA

TYPE regtypeX
   ax    AS INTEGER
   bx    AS INTEGER
   cx    AS INTEGER
   dx    AS INTEGER
   bp    AS INTEGER
   SI    AS INTEGER
   DI    AS INTEGER
   flags AS INTEGER
   DS    AS INTEGER
   es    AS INTEGER
END TYPE

'I use a CALL ABSOLUTE interrupt routine: Program can run in QB 1.1
DECLARE SUB INTERRUPTy (intnum AS INTEGER, REG AS regtypeX)


'.............................................................................

DEFINT A-Z
CONST TOTALBUF = 2000             'file buffer size
CONST dc = 0, AC = 1              'indexs to huffman and quant tables
CONST false = 0, true = NOT false
CONST palsize = 256 * 3           'palette size for 8bit SVGA modes


'General SVGA card parameters
TYPE vesainfoblock
 'Values returned by VESA interrupt
 VESASignature       AS STRING * 4
 VESAVersion         AS INTEGER
 OEMStringPtr        AS LONG
 capabilities        AS LONG
 VIDEOMODEPTR        AS INTEGER
 VIDEOMODESEG        AS INTEGER
 totalmemory         AS INTEGER
 Reserved            AS STRING * 236
'Filled by program
 modenum             AS INTEGER    'mode selected
 modemax             AS INTEGER    'number of modes available
 bytespixel          AS INTEGER    'bytes/pixel in mode selected
 xres                AS INTEGER    'screen res
 yres                AS INTEGER
 BYTESROW            AS LONG
 bpp                 AS INTEGER    'bits per pixel
 winsize             AS LONG       'paging window size (we suppose single Win)
 winseg              AS INTEGER    'segment of window
 numberofbanks       AS INTEGER    'max nr of banks in present mode
 bw                  AS INTEGER    'using an 8 bit mode and a B/W palette
 charx               AS INTEGER    'size of default scaled chars
 chary               AS INTEGER
 WINMASK             AS LONG       'size of window -1 (AND mask)
END TYPE

'Standard SVGA Info block returned by interrupt call. Useful data is
'copied to vesaInfoBlock
TYPE vesaModeinfoBlock
 Modeattributes      AS INTEGER
 WinAAttributes      AS STRING * 1
 WinBAttributes      AS STRING * 1
 WinGranularity      AS INTEGER
 winsize             AS INTEGER
 winAsegment         AS INTEGER
 WinBSegment         AS INTEGER
 WinFuncPtr          AS LONG
 bytesperscanline    AS INTEGER
 xres                AS INTEGER
 yres                AS INTEGER
 XCharSize           AS STRING * 1
 YCharSize           AS STRING * 1
 NumberOfPlanes      AS STRING * 1
 bpp                 AS STRING * 1
 numberofbanks       AS STRING * 1
 MemoryModel         AS STRING * 1
 BankSize            AS STRING * 1
 numpages            AS STRING * 1
 Rsvd                AS STRING * 1
 RedMaskSize         AS STRING * 1
 RedFieldPosition    AS STRING * 1
 GreenMaskSize       AS STRING * 1
 GreenFieldPosition  AS STRING * 1
 BlueMaskSize        AS STRING * 1
 BlueFieldPosition   AS STRING * 1
 RsvdMaskSize        AS STRING * 1
 DirectColorModeInfo AS STRING * 1
 Reserved            AS STRING * 216
END TYPE


TYPE VESAsorttype        'used by VESASelect mode
 INDEX AS LONG           'the number user has to type to select the mode
 MODE AS INTEGER         'VESA mode nr
 CAPTION AS STRING * 35  'mode description for the user
END TYPE

'stores  the JPEG image parmeters
TYPE JpegType
  jfifmajor     AS STRING * 1   'version
  jfifMinor     AS STRING * 1
  densunits     AS STRING * 1   'density units and values (not used)
  Xdens         AS INTEGER
  ydens         AS INTEGER
  ThWidth       AS STRING * 1   'thumbnail size
  Theigth       AS STRING * 1
  rows          AS INTEGER      'jpeg height
  cols          AS INTEGER      'jpeg width
  samplesyx     AS INTEGER      'sampling ratios
  samplesyy     AS INTEGER      'sampling ratios
  samplescbcrx  AS INTEGER
  samplescbcry  AS INTEGER
  qty           AS INTEGER      'number of quantization tables
  qtcbr         AS INTEGER
  HDCTY         AS INTEGER      'number of huffman tables (DC and AC)
  HDCTCBR       AS INTEGER
  HaCTY         AS INTEGER
  HaCTcbr       AS INTEGER
  numcomp       AS INTEGER      'number of components
  restart       AS INTEGER      'blocks between restart marks
  size          AS LONG         'FILE SIZE
  IMAGESTART    AS LONG         'NOT USED
END TYPE

'table used to store the Huffman tree values
TYPE Huffmanentry               'a type for huffman tables
  INDEX         AS LONG         'the output value
  code          AS INTEGER      'searched value
  size          AS INTEGER      'a size mask
END TYPE

TYPE Huffmantreeentry           'a type for huffman tree
  code          AS INTEGER      'searched value
  is1           AS INTEGER      'index to left branch
  is0           AS INTEGER      'index to right branch
END TYPE


'lookup to store the zig-zag indexs
TYPE zigzagtype
 xp             AS INTEGER
 yp             AS INTEGER
END TYPE

'used by the file menu to store the file selector windows parameters
TYPE menutype
 top     AS INTEGER
 heigth  AS INTEGER
 left    AS INTEGER
 wdth    AS INTEGER
 typ     AS INTEGER
 curs    AS INTEGER
 count   AS INTEGER
 tline   AS INTEGER
 file    AS INTEGER
END TYPE

'------------------------------------------------------------------------
'SHARED VARIABLES. Find SHARED keywords in the SUBS...
' This is a non-portable feature of QB, you can decide which SUB
' shares which variable.
'
'simple vars
DIM win, jfile, temppath$         'file vars
DIM viw AS INTEGER                'this 8X8 block is to be displayed?

'main file buffer variables
DIM buf$, bufptr AS LONG, endptr AS LONG, find$:
find$ = CHR$(255) + CHR$(0)      'this string must be removed from buffer

DIM buf2ptr AS INTEGER           'pointer to Huffman decoder secondary buffer
DIM CurBank AS INTEGER           'svga status
DIM time!                        'timer start
DIM nofast                       '1 selects accurate IDCT

'UDT
DIM vesainfo  AS vesainfoblock
DIM display AS vesaModeinfoBlock
DIM Regs  AS regtypeX
DIM jpeg AS JpegType

'JPEG tables

' quantization
REDIM quant(0, 0, 0)
'huffman decoding
DIM Hufftree(1024) AS Huffmantreeentry
DIM huffstart(8)
'zigzag
DIM zz(0 TO 63)  AS zigzagtype


'SVGA LUT
CONST l1 = -26, l2 = 281
DIM rlook(l1 TO l2), glook(l1 TO l2), g2look(l1 TO l2), blook(l1 TO l2)
DIM xoff(2400), yseg(1600), ybank(1600)

'bit mask tables
'a classical one
DIM PwrsOf2(-1 TO 31) AS LONG
'used in huffman decoder GOSUBS
DIM bit3(-1 TO 15)  AS INTEGER
DIM bit4(0 TO 15) AS INTEGER, bit1(-1 TO 15) AS INTEGER

'LUTS used to convert from Y-CB-CV to RGB
'They should have indexes from -128 to 127. They are bigger to act also
'as limiters of the (unaccurate) output of the IDCT fixed point routine

CONST limrgb = 250
CONST lim2rgb = -limrgb

DIM rcrv(lim2rgb TO limrgb)
DIM gcbv(lim2rgb TO limrgb)
DIM gcrv(lim2rgb TO limrgb)
DIM bcbv(lim2rgb TO limrgb)

'This one is used to send an entire mcu to screen
REDIM rgb(0, 0, 0)  AS INTEGER

'List of mode descriptions for the mode selector
REDIM modes(0)  AS VESAsorttype

email$ = "antonigual@eic.ictnet.es"

'DEF FN SNIPPETS-----------------------------------------------------------
'converts unsigned word stored in a long to an integer
DEF fnuns2int% (u&)
  IF u& > 32767 THEN fnuns2int% = u& - 65536 ELSE fnuns2int% = u&
END DEF

'DEBUG: prints bin value
DEF fnb$ (v&)
    a$ = SPACE$(32)
    FOR i% = 1 TO 32
        IF (PwrsOf2(32 - i%) AND v&) THEN
            MID$(a$, i%, 1) = "1"
        ELSE
            MID$(a$, i%, 1) = "0"
        END IF
    NEXT
    fnb$ = a$: a$ = ""
END DEF

'INITIALIZATIONS-----------------------------------------------------------

RESTORE zig2: FOR i = 0 TO 63: READ zz(i).xp, zz(i).yp: NEXT
zig2:  'Zigzag patterns for reordering quantization tables and vectors
DATA 0,0
DATA 0,1,1,0
DATA 2,0,1,1,0,2
DATA 0,3,1,2,2,1,3,0
DATA 4,0,3,1,2,2,1,3,0,4
DATA 0,5,1,4,2,3,3,2,4,1,5,0
DATA 6,0,5,1,4,2,3,3,2,4,1,5,0,6
DATA 0,7,1,6,2,5,3,4,4,3,5,2,6,1,7,0
DATA 7,1,6,2,5,3,4,4,3,5,2,6,1,7
DATA 2,7,3,6,4,5,5,4,6,3,7,2
DATA 7,3,6,4,5,5,4,6,3,7
DATA 4,7,5,6,6,5,7,4
DATA 7,5,6,6,5,7
DATA 6,7,7,6
DATA 7,7


FOR i = -1 TO 30:
    temp& = 2& ^ i: PwrsOf2(i) = temp&
    IF i < 16 THEN
         bit3(i) = fnuns2int%(temp& - 1)
         bit1(i) = fnuns2int%(-(temp& - 1))
         IF i < 15 THEN bit4(i + 1) = fnuns2int%(temp&)
    END IF

    'PRINT : PRINT HEX$(pwrsof2(i)), HEX$(BIT1(i));
NEXT
PwrsOf2(31) = &H80000000





temp% = CINT(1.402 * 128)
FOR i% = lim2rgb TO limrgb: rcrv(i%) = CINT(1.402 * (i%))
IF ABS(i%) > 128 THEN rcrv(i%) = temp% * SGN(rcrv%(i%))
NEXT


temp% = CINT(-3.4414 * 128)  'limiting value
FOR i% = lim2rgb TO limrgb: gcbv(i%) = CINT(-.34414 * (i%))
IF ABS(i%) > 128 THEN gcbv(i%) = temp% * SGN(gcbv%(i%))
NEXT


temp% = CINT(-.71414 * 128)
FOR i% = lim2rgb TO limrgb: gcrv(i%) = CINT(-.71414 * (i%))
IF ABS(i%) > 128 THEN gcrv(i%) = temp% * SGN(gcrv%(i%))
NEXT


FOR i% = lim2rgb TO limrgb: bcbv(i%) = CINT(1.772 * (i%))
IF ABS(i%) > 128 THEN bcbv(i%) = temp% * SGN(bcbv%(i%))
NEXT




'START------------------------------------------------------------------

DetectWinTemp           'for file selector
nofast = -1             'select accurate IDCT
SCREEN 0: CLS
SVGAInit             'check SVGA. Id not present, the routine stops program
dummy$ = getcurdir(1)   'for file selector

a = SVGAsetmode(&H112)  'Check if we can enter the default SVGA mode
R$ = "F"': GOTO Selection'enter main loop at file selector

'--------- Main Loop (Menu) ----------
DO
Selection:
  SELECT CASE UCASE$(R$)
 
  CASE "F"                             'select,open file and get parameters
    a = SVGAsetmode(3)
    'select a file and open it
    f$ = SelectAFile("Select a JPEG file to view", "jpg")
    IF f$ = "" THEN EXIT DO
    jfile = FREEFILE
    OPEN f$ FOR BINARY AS #jfile
    'reset buffer
    endptr = TOTALBUF: buf$ = SPACE$(endptr): bufptr = endptr + 1
    'get file parameters (and tables) to be displayed in the menu
    ok = JPEGGetParms(jfile)
    CLOSE #jfile
    IF ok THEN
      IF vesainfo.modenum THEN R$ = "V" ELSE R$ = ""
    ELSE
      a$ = INPUT$(1): GOTO Continue
    END IF
 
  CASE "V"                            'display the file
    OPEN f$ FOR BINARY AS #jfile
    'reset buffer
    endptr = TOTALBUF: buf$ = SPACE$(endptr): bufptr = endptr + 1
    escaped = 0
    'get file parameters and tables for true
    IF JPEGGetParms(jfile) THEN
      '??????
      IF vesainfo.modenum THEN a = SVGAsetmode(3)
      IF vesainfo.bytespixel <> 1 THEN
        IF jpeg.numcomp = 1 THEN R$ = "M": CLOSE jfile: GOTO Continue
      END IF
      'set svga mode
      'ON ERROR GOTO rendererror
      a = SVGAsetmode(vesainfo.modenum)
                          
      'Center image: Set screen position of thje top left corner
      y0 = ((vesainfo.yres - jpeg.rows) \ 2) AND &HFFF0
      x0 = ((vesainfo.xres - jpeg.cols) \ 2) AND &HFFF0
      'if first line of image is offscreen display a warning
      IF y0 < 0 THEN
          yy = 0 'vesainfo.chary + 0
          SVGAPRINT "The centered image is bigger than the screen", 0, yy, vesainfo.charx, vesainfo.chary, 2, 3
          yy = yy + vesainfo.chary + 2
          SVGAPRINT "and JPEGs must be decoded from the beggining", 0, yy, vesainfo.charx, vesainfo.chary, 2, 3
          yy = yy + vesainfo.chary + 2
          SVGAPRINT "Please wait until image shows or press ESC.", 0, yy, vesainfo.charx, vesainfo.chary, 2, 3
      END IF
                          
      'init timer
      time! = TIMER: DO: LOOP UNTIL time! <> TIMER: time! = TIMER
      'reset Huffman decoder buffer
      buf2ptr = 0
      'display image
      SELECT CASE jpeg.numcomp
      CASE 3: escaped = JPEGRenderColor(jfile, x0, y0)
      CASE 1: escaped = JPEGRenderMono(jfile, x0, y0)
      END SELECT
      ERASE Hufftree, quant
      R$ = ""
    ELSE
       R$ = "F"
    END IF
    CLOSE #jfile
    'time will be displayed in the menu
    time! = TIMER - time!
    'if displaying was not escaped, let user watch the image
    IF NOT escaped THEN WHILE LEN(INKEY$) = 0: WEND

  CASE "M"                       'select and change svga mode
      fail = SVGASelectMode
      R$ = "V"
  CASE "X"                       'exit
      EXIT DO
 
  CASE ELSE
      R$ = ""
  END SELECT
 
  ON ERROR GOTO 0
  a = SVGAsetmode(3)                   'set text screen
  JPEGViewParms                        'view present JPEG params
  menu                                 'display user menu
  WHILE LEN(R$) = 0: R$ = INKEY$: WEND
Continue:
LOOP

'CLEANUP AND END-----------------------------------------------------------
                                    'back to text
a = SVGAsetmode(3)                  'erase DYNAMICs
ERASE xoff, yseg, ybank             'Reset dir
dummy$ = getcurdir(0)
LOCATE 12, 1
PRINT " Thank you for trying JPEG VIEWER  by Antoni Gual ("; email$; ")"
DO: LOOP UNTIL LEN(INKEY$)
END




'ERROR HANDLERS------------------------------------------------------------

'
diskreadyerror: errata% = ERR: RESUME NEXT


rendererror: a = SVGAsetmode(3): ERROR ERR: END

SUB DetectWinTemp
'detect Windows 95 and the temp path, setting global variables
'used by  all routines based in SHELL commands:
'  file selector
'  current dir saver

'find temp path
SHARED win, temppath$
    temppath$ = ENVIRON$("TEMP") + "\"
    IF temppath$ = "\" THEN
        PRINT "Some routines in this program require the TEMP environment variable to be set"
        PRINT "Can't continue.Please set TEMP variable to some existing directory"
        END
    END IF

    'detect windows 95 & 98
    tempfile$ = temppath$ + "detwin.txt"
    doscmd$ = "ver >" + tempfile$
    SHELL doscmd$
    f1 = FREEFILE: OPEN tempfile$ FOR INPUT AS #f1:
    win = 0
    WHILE NOT EOF(f1) AND win = 0
        LINE INPUT #f1, a$
        IF INSTR(a$, "Windows") THEN win = -1
    WEND
    CLOSE f1
    KILL tempfile$
END SUB

FUNCTION DiskReady% (d$)
'
'Nearly Self-contained drive check routine
' Use as you want, only give me credit
'
'returns:   0 if drive exists and it's ready
'           1 if drive is not ready
'           2 if drive does not exist
'           3 if drive exists and disk is an audio CD
'
'supposed to run in any dos from MSDOS 3.1. Tested in Win 95 and DOS 6.2
'detects RAM disks and it's supposed to detect network units
'Does not use interrupt calls!
'---------------------------------------------------------------------------
'To use it into your programs simply copy it and add the line
'   diskreadyerror: errata% = ERR: RESUME NEXT
'(without the leading ') after the END of the main program
'---------------------------------------------------------------------------
    SHARED errata%
    errata% = 0
    drive$ = LEFT$(UCASE$(d$), 1) + ":"
    IF drive$ = "B:" THEN
     OUT &H70, &H10
     IF (INP(&H71) AND 7) = 0 THEN DiskReady% = 2: EXIT FUNCTION
    END IF
    ON ERROR GOTO diskreadyerror
    num% = FREEFILE
    OPEN drive$ + "\track01.cda" FOR INPUT AS #num%
    SELECT CASE errata%
     CASE 53: DiskReady% = 0
     CASE 71: DiskReady% = 1
     CASE 76: DiskReady% = 2
     CASE 0: DiskReady% = 3: CLOSE num%
     CASE ELSE
      PRINT "Unexpected error value "; errata%; "in Diskready function": END
    END SELECT
    ON ERROR GOTO 0

END FUNCTION

FUNCTION getcurdir$ (save%)
'if save <>0 then save cur dir to a static string
'if save =0 then chdir to the previously saved dir
'needs the shared variables temppath$ and win to be set
SHARED win, temppath$
STATIC a$
IF save% THEN
 tempfile$ = temppath$ + "curdir.txt"
 SHELL "cd >" + tempfile$
 f% = FREEFILE: OPEN tempfile$ FOR INPUT AS f%
 LINE INPUT #f%, a$
 CLOSE f%: KILL tempfile$
 IF LEFT$(a$, 1) <> "\" THEN a$ = a$ + "\"
ELSE
 IF win THEN a1$ = CHR$(34) + a$ ELSE a1$ = a$
 SHELL a1$
 SHELL "cd " + a1$
END IF
getcurdir$ = a$
END FUNCTION

SUB INTERRUPTy (intnum AS INTEGER, REG AS regtypeX)
'standard interrupt call compatibility with QBasic 1.1
STATIC a() AS LONG, bReady AS INTEGER, x AS INTEGER, y AS INTEGER
IF NOT bReady THEN
    i = 50: DIM a(1 TO i) AS LONG
    a(1) = &H53EC8B55: a(2) = &H1E575651: a(3) = &H5E8B9C06: a(4) = &HA078B0E
    a(5) = &HC70774E4: a(6) = &HE9FFFF07: a(7) = &HEC8300A1: a(8) = &HB3F88A0A
    a(9) = &HE85E89CD: a(10) = &HCBEA46C7: a(11) = &H74253C90: a(12) = &H75263C04
    a(13) = &HEA46C714: a(14) = &H46C701E8: a(15) = &HC7CB00EC: a(16) = &H2C2EE46
    a(17) = &HF046C7: a(18) = &H85E8B90: a(19) = &H5E8B37FF: a(20) = &HE37FF06
    a(21) = &H50008FB8: a(22) = &HE85E8D16: a(23) = &H8BDA8C53: a(24) = &H378B0A5E
    a(25) = &H8E0C5E8B: a(26) = &H10448B1F: a(27) = &H75FFFF3D: a(28) = &H50C28B02
    a(29) = &H3D12448B: a(30) = &H275FFFF: a(31) = &HC08EC28B: a(32) = &H5C8B048B
    a(33) = &H44C8B02: a(34) = &H8B06548B: a(35) = &H748B0C7C: a(36) = &H9CCB1F0A
    a(37) = &H83EC8B55: a(38) = &H1E5620C5: a(39) = &H89E476C5: a(40) = &H25C8904
    a(41) = &H89044C89: a(42) = &H7C890654: a(43) = &H12448C0C: a(44) = &H8F10448F
    a(45) = &H448F0A44: a(46) = &HE448F08: a(47) = &H9D0EC483: a(48) = &H5E5F1F07
    a(49) = &HCA5D5B59: a(50) = &H9165000A
    S1 = 0: S2 = 0: p = VARPTR(a(1)): DEF SEG = VARSEG(a(1))
    FOR i = 0 TO 199
        S1 = (S1 + PEEK(p + i)) MOD 255: S2 = (S2 + S1) MOD 255
    NEXT i
    IF S1 OR S2 THEN ERROR 2: intnum = -1: EXIT SUB ' Checksum Error
    bReady = -1
END IF
x = VARSEG(REG): y = VARPTR(REG)
DEF SEG = VARSEG(a(1))
CALL ABSOLUTE(intnum, x, y, x, y, 0)

END SUB

SUB JPEGGet8x8 (vector(), comp, dcCoef) STATIC
' Reads enough bits from JPEG file so Huffman decoder can build an 8X8 block
' Then reorders block based on zigzafg table, dequantizaes and IDCT
' transforms the block so the returned block is an ordered 8x8 Y, Cb or Cr
' component block
'
' Decoding of progressive jpegs would need saving all 8x8 blocks at the output
'  of the huffman decoder so they could be updated with the data from several
'  scans before zigzag-dequant-idct-display-ing them

' vector Returns a block
' comp tells us if it's a luminance(Y) or a chrominance component, as differnt
'  dequant-huffman tables must be used
' In dccoef we receive the dc component  from last block and return
'  the dc component of this block (dc component is coded incrementally)

'array of params for present file
SHARED jpeg AS JpegType

'if viw=0 present block is offscreen so SUB is exited after Huffman decoding
SHARED viw AS INTEGER

SHARED quant()


'zigzag table
SHARED zz() AS zigzagtype

'selects one of the IDCT procedures
SHARED nofast

'HUFFMAN DECODER-----------------------------------------------------------
' Reads enough bits from JPEG file to build an 8X8 block and de-zigzags it
' A block's coefficient is encoded as two variable length values:
'   an entry to a huffman table and the actual value.
' The entry to Huff table indexes a code made of 2 nibbles
'   codes 0 and 3270 have special meanings; for the rest
'   high nibble is an offset from the present position in the block
'   low nibble is nr of bits to retrieve for the value
'--------------------------------------------------------------------------
  'select correct  Huffman and dequant tables
  SELECT CASE comp
  CASE 1
     huffdcnum = jpeg.HDCTY
     huffacnum = jpeg.HaCTY
     quantnum = jpeg.qty
     tx = 0
  CASE 2
     huffdcnum = jpeg.HDCTCBR
     huffacnum = jpeg.HaCTcbr
     quantnum = jpeg.qtcbr
     tx = 2
  CASE ELSE
  END SELECT

  'vector values not found have to be zero, so zero all the vector
  REDIM vector(0 TO 7, 0 TO 7)
       
  'The DC coefficient is incremental
  nbits = JPEGGetHuff(tx)
  dcCoef = dcCoef + JPEGGetNBits(nbits)
  vector(0, 0) = dcCoef
       
  'AC Coefficients are calculated from scratch
  k = 1
  DO
    dekode = JPEGGetHuff(tx + 1)
    SELECT CASE dekode
    CASE 0 'EndOfBlock.Rest of vector is already padded with 0's (REDIM)
      EXIT DO
    CASE 3270 'ZeroRunLength encountered  3270=15*256+0
      k = k + 16
    CASE ELSE 'a true coefficient follows
      'first nibble: index increment
      k = k + dekode \ 16
      'second nibble:nr of bits of the coefficient
      vector(zz(k).xp, zz(k).yp) = JPEGGetNBits(dekode AND 15)
      k = k + 1
    END SELECT
  LOOP UNTIL k > 63


'if block must not be viewed SUB is exited
IF NOT viw THEN EXIT SUB

'Dequantization and IDCT routines-----------------------------------------------

'The true IDCT is as follows:
'The 4 dimensional IDCT coefficients matrix
'DIM dct!(X,Y,U,V)
'FOR x = 0 TO 7           'Initialize our cosine table
' FOR y = 0 TO 7
'    FOR u = 0 TO 7
'     FOR v = 0 TO 7
'        t! = COS((2 * x + 1) * u * .1963495) * COS((2 * y + 1) * v * .1963495)
'        IF u = 0 THEN t! = t! * .707107
'        IF v = 0 THEN t! = t! * .707107
'        dct!(x, y, u, v) = t!
'     NEXT v
'    NEXT u
' NEXT y
'NEXT x
'
'IDCT calculation for a given vector: output in array2
'FOR x = 0 TO 7
'    FOR y = 0 TO 7
'        sum! = 0
'        FOR v = 0 TO 7
'            FOR u = 0 TO 7
'                temp! = vector(u, v)
'                IF temp! THEN temp! = temp! * dct!(x, y, u, v)
'                sum! = sum! + temp!
'            NEXT u
'        NEXT v
'        array2!(x, y) = sum!+128!
'   NEXT y
'NEXT x
'
'The actual methods used there are ported from the C source examples by the
'independant JPEG group. Both come from research papers :it is an important
'bottleneck in any JPEG decoder.

'temporals for the IDCT routines
DIM z1 AS LONG, z2 AS LONG, z3 AS LONG, z4 AS LONG, z5 AS LONG
DIM z10 AS LONG, z11 AS LONG, z12 AS LONG, z13 AS LONG
DIM tmp0 AS LONG, tmp1 AS LONG, tmp2 AS LONG, tmp3 AS LONG
DIM tmp4 AS LONG, tmp5 AS LONG, tmp6 AS LONG, tmp7 AS LONG
DIM tmp10 AS LONG, tmp11 AS LONG, tmp12 AS LONG, tmp13 AS LONG


IF nofast THEN



'Inverse Discrete Cosinus Transform & dequantization using fixed point
'Loeffler,Ligtenberg and Moschytz algorythm  (the accurate one) (default)

 CONST fix029 = 2446&
 CONST FIX039 = -3196&
 CONST FIX054 = 4433&
 CONST FIX076 = 6270&
 CONST FIX089 = -7373&
 CONST FIX117 = 9633&
 CONST fix150 = 12299&
 CONST FIX184 = -15137&
 CONST FIX196 = -16069&
 CONST fix205 = 16819&
 CONST FIX256 = -20995&
 CONST fix307 = 25172&
 CONST x1& = &H20000
 CONST x2& = &H2000
 CONST x = &H1000
'row calc
FOR u = 7 TO 0 STEP -1
 'if all row zeros, short circuit row calc
 IF (vector(1, u) OR vector(2, u) OR vector(3, u) OR vector(4, u) OR vector(5, u) OR vector(6, u) OR vector(7, u)) = 0 THEN
   tmp0 = vector(0, u) * quant(quantnum, 0, u) * 2
   vector(0, u) = tmp0
   vector(1, u) = tmp0
   vector(2, u) = tmp0
   vector(3, u) = tmp0
   vector(4, u) = tmp0
   vector(5, u) = tmp0
   vector(6, u) = tmp0
   vector(7, u) = tmp0
 ELSE
 z2 = vector(2, u) * quant(quantnum, 2, u)
 z3 = vector(6, u) * quant(quantnum, 6, u)
 z1 = (z2 + z3) * FIX054
 tmp2 = z1 + (z3 * FIX184)
 tmp3 = z1 + (z2 * FIX076)
 z2 = vector(0, u) * quant(quantnum, 0, u)
 z3 = vector(4, u) * quant(quantnum, 4, u)
 tmp0 = x2& * (z2 + z3)
 tmp1 = x2& * (z2 - z3)
 tmp10 = tmp0 + tmp3
 tmp13 = tmp0 - tmp3
 tmp11 = tmp1 + tmp2
 tmp12 = tmp1 - tmp2
 tmp0 = vector(7, u) * quant(quantnum, 7, u)
 tmp1 = vector(5, u) * quant(quantnum, 5, u)
 tmp2 = vector(3, u) * quant(quantnum, 3, u)
 tmp3 = vector(1, u) * quant(quantnum, 1, u)
 z1 = tmp0 + tmp3
 z2 = tmp1 + tmp2
 z3 = tmp0 + tmp2
 z4 = tmp1 + tmp3
 z5 = (z3 + z4) * FIX117
 tmp0 = tmp0 * fix029
 tmp1 = tmp1 * fix205
 tmp2 = tmp2 * fix307
 tmp3 = tmp3 * fix150
 z1 = z1 * FIX089
 z2 = z2 * FIX256
 z3 = z3 * FIX196
 z4 = z4 * FIX039
 z3 = z3 + z5
 z4 = z4 + z5
 tmp0 = tmp0 + z1 + z3
 tmp1 = tmp1 + z2 + z4
 tmp2 = tmp2 + z2 + z3
 tmp3 = tmp3 + z1 + z4
 vector(0, u) = (tmp10 + tmp3) \ x
 vector(7, u) = (tmp10 - tmp3) \ x
 vector(1, u) = (tmp11 + tmp2) \ x
 vector(6, u) = (tmp11 - tmp2) \ x
 vector(2, u) = (tmp12 + tmp1) \ x
 vector(5, u) = (tmp12 - tmp1) \ x
 vector(3, u) = (tmp13 + tmp0) \ x
 vector(4, u) = (tmp13 - tmp0) \ x
  END IF
NEXT
'column calcs
FOR v = 0 TO 7
 z2 = vector(v, 2)
 z3 = vector(v, 6)
 z1 = (z2 + z3) * FIX054
 tmp2 = z1 + (z3 * FIX184)
 tmp3 = z1 + (z2 * FIX076)
 tmp0 = x2& * (vector(v, 0) + vector(v, 4))
 tmp1 = x2& * (vector(v, 0) - vector(v, 4))
 tmp10 = tmp0 + tmp3
 tmp13 = tmp0 - tmp3
 tmp11 = tmp1 + tmp2
 tmp12 = tmp1 - tmp2
 tmp0 = vector(v, 7)
 tmp1 = vector(v, 5)
 tmp2 = vector(v, 3)
 tmp3 = vector(v, 1)
 z1 = tmp0 + tmp3
 z2 = tmp1 + tmp2
 z3 = tmp0 + tmp2
 z4 = tmp1 + tmp3
 z5 = (z3 + z4) * FIX117
 tmp0 = tmp0 * fix029
 tmp1 = tmp1 * fix205
 tmp2 = tmp2 * fix307
 tmp3 = tmp3 * fix150
 z1 = z1 * FIX089
 z2 = z2 * FIX256
 z3 = z3 * FIX196
 z4 = z4 * FIX039
 z3 = z3 + z5
 z4 = z4 + z5
 tmp0 = tmp0 + z1 + z3
 tmp1 = tmp1 + z2 + z4
 tmp2 = tmp2 + z2 + z3
 tmp3 = tmp3 + z1 + z4
 vector(v, 0) = (tmp10 + tmp3) \ x1&
 vector(v, 7) = (tmp10 - tmp3) \ x1&
 vector(v, 1) = (tmp11 + tmp2) \ x1&
 vector(v, 6) = (tmp11 - tmp2) \ x1&
 vector(v, 2) = (tmp12 + tmp1) \ x1&
 vector(v, 5) = (tmp12 - tmp1) \ x1&
 vector(v, 3) = (tmp13 + tmp0) \ x1&
 vector(v, 4) = (tmp13 - tmp0) \ x1&
NEXT
EXIT SUB

'Arai, Agui, and Nakajima's IDCT algorithm (less accurate, but faster)
'You can get rid of this one!
ELSE

CONST FIX1082 = 277& '     /* FIX(1.082392200) */
CONST fix1412 = 362& '     /* FIX(1.414213562) */
CONST FIX1847 = 473& '     /* FIX(1.847759065) */
CONST FIX2613 = 669& '     /* FIX(2.613125930) */
CONST x11& = &H8&

FOR u = 7 TO 0 STEP -1
    'if all row zeros, copy first value
    IF (vector(1, u) OR vector(2, u) OR vector(3, u) OR vector(4, u) OR vector(5, u) OR vector(6, u) OR vector(7, u)) = 0 THEN
      tmp0 = vector(0, u) * quant(quantnum, 0, u)
      vector(0, u) = tmp0
      vector(1, u) = tmp0
      vector(2, u) = tmp0
      vector(3, u) = tmp0
      vector(4, u) = tmp0
      vector(5, u) = tmp0
      vector(6, u) = tmp0
      vector(7, u) = tmp0
    ELSE
    tmp0 = vector(0, u) * quant(quantnum, 0, u)'even part
    tmp1 = vector(2, u) * quant(quantnum, 2, u)
    tmp2 = vector(4, u) * quant(quantnum, 4, u)
    tmp3 = vector(6, u) * quant(quantnum, 6, u)
    tmp10 = tmp0 + tmp2
    tmp11 = tmp0 - tmp2
    tmp13 = tmp1 + tmp3
    tmp12 = (tmp1 - tmp3) * fix1412 \ 256 - tmp13
    tmp0 = tmp10 + tmp13
    tmp3 = tmp10 - tmp13
    tmp1 = tmp11 + tmp12
    tmp2 = tmp11 - tmp12

    tmp4 = vector(1, u) * quant(quantnum, 1, u)'odd part
    tmp5 = vector(3, u) * quant(quantnum, 3, u)
    tmp6 = vector(5, u) * quant(quantnum, 5, u)
    tmp7 = vector(7, u) * quant(quantnum, 7, u)
    z13 = tmp6 + tmp5
    z10 = tmp6 - tmp5
    z11 = tmp4 + tmp7
    z12 = tmp4 - tmp7
   
    tmp7 = z11 + z13
    tmp11 = (z11 - z13) * fix1412 \ 256
    z5 = (z10 + z12) * FIX1847
    tmp10 = (z12 * FIX1082 - z5) \ 256
    tmp12 = (z10 * -FIX2613 + z5) \ 256
    tmp6 = tmp12 - tmp7
    tmp5 = tmp11 - tmp6
    tmp4 = tmp10 + tmp5
    vector(0, u) = tmp0 + tmp7
    vector(7, u) = tmp0 - tmp7
    vector(1, u) = tmp1 + tmp6
    vector(6, u) = tmp1 - tmp6
    vector(2, u) = tmp2 + tmp5
    vector(5, u) = tmp2 - tmp5
    vector(4, u) = tmp3 + tmp4
    vector(3, u) = tmp3 - tmp4
    END IF
  NEXT u
  FOR v = 0 TO 7
    tmp10 = vector(v, 0) + vector(v, 4)
    tmp11 = vector(v, 0) - vector(v, 4)
    tmp13 = vector(v, 2) + vector(v, 6)
    tmp12 = (vector(v, 2) - vector(v, 6) * fix1412) \ 256 - tmp13
    tmp0 = tmp10 + tmp13
    tmp3 = tmp10 - tmp13
    tmp1 = tmp11 + tmp12
    tmp2 = tmp11 - tmp12
    z13 = vector(v, 5) + vector(v, 3)       '/* Odd part */
    z10 = vector(v, 5) - vector(v, 3)
    z11 = vector(v, 1) + vector(v, 7)
    z12 = vector(v, 1) - vector(v, 7)
   
    tmp7 = z11 + z13            '            /* phase 5 */
    tmp11 = (z11 - z13) * fix1412 \ 256
    z5 = (z10 + z12) * FIX1847
    tmp10 = (z12 * FIX1082 - z5) \ 256
    tmp12 = (z10 * -FIX2613 + z5) \ 256
    tmp6 = tmp12 - tmp7'                     /* phase 2 */
    tmp5 = tmp11 - tmp6
    tmp4 = tmp10 + tmp5
    '/* Final output stage: scale down by a factor of 8
    vector(v, 0) = (tmp0 + tmp7) \ x11& 'AND &HFF
    vector(v, 7) = (tmp0 - tmp7) \ x11& 'AND &HFF
    vector(v, 1) = (tmp1 + tmp6) \ x11& 'AND &HFF
    vector(v, 6) = (tmp1 - tmp6) \ x11& 'AND &HFF
    vector(v, 2) = (tmp2 + tmp5) \ x11& 'AND &HFF
    vector(v, 5) = (tmp2 - tmp5) \ x11& 'AND &HFF
    vector(v, 4) = (tmp3 + tmp4) \ x11& 'AND &HFF
    vector(v, 3) = (tmp3 - tmp4) \ x11& 'AND &HFF
NEXT v
END IF

END SUB

FUNCTION JPEGGetByte STATIC
'***buffered, all JPEG file access goes thru it
'gets a single byte from file. At reading, it converts the pairs FF 00 to 00's

SHARED buf$, bufptr AS LONG, endptr  AS LONG, find$, jfile

'for QB4.5
DEF SEG

'for PDS 7.1 far strings
'DEF SEG = sseg(buf$)

IF bufptr > endptr THEN
 GET #jfile, , buf$: bufptr = SADD(buf$): endptr = TOTALBUF + bufptr - 1
 i0 = INSTR(buf$, find$)
 IF PEEK(endptr) = 255 THEN endptr = endptr - 1: SEEK #jfile, SEEK(jfile) - 1
 DO WHILE i0 > 0
  MID$(buf$, i0 + 1) = MID$(buf$, i0 + 2): endptr = endptr - 1
  i0 = INSTR(i0 + 1, buf$, find$)
 LOOP
END IF

JPEGGetByte = PEEK(bufptr): bufptr = bufptr + 1
END FUNCTION

FUNCTION JPEGGetHuff (posini)
'Called by JpegGet8x8
'Gets bits from file until they match a Huffman table entry. When match
' found it returns the associated code.
'The table is in the form of a binary tree


'some tables built at JPEGGetParms
SHARED Hufftree()  AS Huffmantreeentry 'the unique array of trees
SHARED huffstart()                     'pointers to the start of each tree

SHARED PwrsOf2() AS LONG

'local buffer to ease the task of getting bits 1 by 1
SHARED buf2 AS LONG
SHARED buf2ptr AS INTEGER

  'init pointer to tree array
  hptr = huffstart(posini)
  'if not enough bits in local buffer, refill it from main buffer
  WHILE buf2ptr < 16
      buf2 = (buf2 AND &HFFFF&) * 256 OR JPEGGetByte: buf2ptr = buf2ptr + 8
  WEND

  'gather bits until we match a huffman pattern
  DO
    buf2ptr = buf2ptr - 1
    'select branch depending of next bit
    IF buf2 AND PwrsOf2(buf2ptr) THEN
        bptr = Hufftree(hptr).is1
    ELSE
        bptr = Hufftree(hptr).is0
    END IF
    'if at a leaf (0 index) exit loop else explore a new branch
    IF bptr THEN hptr = bptr ELSE EXIT DO
  LOOP
  
  buf2ptr = buf2ptr + 1
  JPEGGetHuff = Hufftree(hptr).code
END FUNCTION

FUNCTION JPEGGetNBits (nbits)
'Called by JpegGet8x8
'Fetches nbits bits from the file, if first bit on it performs the "negation"
'required by Jpeg specs.

SHARED PwrsOf2() AS LONG
SHARED bit3() AS INTEGER, bit4() AS INTEGER, bit1() AS INTEGER

'local buffer to ease the task of getting bits 1 by 1
SHARED buf2 AS LONG
SHARED buf2ptr AS INTEGER

  'if buf2 does'nt have enough bytes, fill it
  WHILE buf2ptr < nbits
    buf2 = (buf2 AND &HFFFF&) * 256 OR JPEGGetByte: buf2ptr = buf2ptr + 8
  WEND

  'get n bits.
  buf2ptr = buf2ptr - nbits
  GetNBits = buf2 \ PwrsOf2(buf2ptr) AND bit3(nbits)
 
  'negate reverse value if apropriate bit is 1 (jpeg spec)
  IF GetNBits AND bit4(nbits) THEN JPEGGetNBits = GetNBits ELSE JPEGGetNBits = GetNBits + bit1(nbits)

END FUNCTION

FUNCTION JPEGGetParms (jfile)
'
'Scans a JPEG to see if we are able to display it. If we are, get Huffman
'and quantization coefs
'When the first baseline start of frame is found, routine is exited
'
'This routine is very tolerant, it accept the different blocks in any order
' In fact a precise sequence should be enforced...
'
'Markers:----------------------------------------------------------------
'FFD8 Start of Image /FFD9 End Of image /FFDA Start of Scan
'
'START OF FRAME      DCT SINGLE   DCT DIFFE   ARITHMETICAL  ARITHMETICAL
'                     FRAME        RENTIAL    SINGLE FRAME  DIFFERENTIAL
'Baseline              FFC0                
'Extended sequential   FFC1         FFC5        FFC9          FFCD
'Progressive           FFC2         FFc6        FFCA          FFCE
'Lossless sequential   FFC3         FFC7        FFCB          FFCF
'
'FFC4 Huffman table  /FFCC Aritmetical table  /FFDB Dequantization table
'FFDC Define Nr of lines /FFDF Expand ref Components /FFDE Define hierarchical
'FFE0 - FFEF App segment /FFF0-FFFD Jpeg extension /FF01 to FFBF Reserved
'FFFE -Comment /  FF00 ==  byte FF
'FFDD -Define restart interval /FFD0 - FFD7 Restart marks  
'---------------------------------------------------------------------------

SHARED jpeg AS JpegType
SHARED imgcomment$
SHARED ACTAbles, DCtables
SHARED quant(), qtables
REDIM quant(0 TO 1, 0 TO 7, 0 TO 7) '2 quantization tables (Y, CbCr)
SHARED tni, tindx
SHARED zz() AS zigzagtype
SHARED marker$, email$

JPEGGetParms = 0
tindx = 0: tni = 0
jpeg.size = LOF(jfile)
qtables = 0                        'Initialize some checkpoint variables
ACTAbles = 0
DCtables = 0
jpeg.restart = 0
SEEK jfile, 1

'check for JPEG SOI marker at start
IF JPEGGetWord& <> &HFFD8& THEN ERROR 99: EXIT FUNCTION

marker$ = ""
DO                                      'Primary control loop for markers
  IF JPEGGetByte = 255 THEN             'Marker Found
   d = JPEGGetByte
   marker$ = marker$ + CHR$(d)
   SELECT CASE d                        'which one is it?
   
   CASE &HC0, &HC1                      'SOF0-1: Frame marker.Only baseline..
    'get frame attributes
    temp4& = JPEGGetWord&                   'Length of segment
    temp0 = JPEGGetByte                 'Data precision
    IF temp0 <> 8 THEN
     PRINT temp0; " bit samples not supported" 'we support only 8 bits
     EXIT FUNCTION
    END IF
    jpeg.rows = JPEGGetWord&
    jpeg.cols = JPEGGetWord&
    ncomp = JPEGGetByte                'Number of components
    'get data for each image component (Y-CB-CR)
    FOR i = 1 TO ncomp
     id = JPEGGetByte
     SELECT CASE id
     CASE 1
      temp1 = JPEGGetByte
      jpeg.samplesyx = temp1 \ 16
      jpeg.samplesyy = temp1 AND 15
      jpeg.qty = JPEGGetByte
     CASE 2, 3
      temp1 = JPEGGetByte
      jpeg.samplescbcrx = temp1 \ 16
      jpeg.samplescbcry = temp1 AND 15
      jpeg.qtcbr = JPEGGetByte
     CASE ELSE
     END SELECT
    NEXT i
   CASE &HC2
     PRINT "Progressive JPEG not supported"
     EXIT FUNCTION
   CASE &HC5 TO &HC7
     PRINT " Differential JPEG not supported."
     EXIT FUNCTION
  
   CASE &HC9 TO &HCF
     PRINT " Arithmetical coded JPEG not supported."
     EXIT FUNCTION
  
   CASE &HC4                             'DHT:  Huffman tables
    IF ACTAbles < 2 OR DCtables < 2 THEN
      JPEGMakeHuffTree
    ELSE
      PRINT " This file has more than 2 Huffman tables per component. Not supported"
      EXIT FUNCTION
    END IF

   CASE &HD8 'SOI                        'Start of image.Should not be here
     PRINT "Start of image marker found. It should not be here."
     EXIT FUNCTION
  
   CASE &HD9 'EOI                        'END of image.(Should be the EOF)
     PRINT "End of image marker found before any scan."
     EXIT FUNCTION
   CASE &HDA 'SOS                        'start of scan.The true image
    'get scan header parameters                             '
    temp4& = JPEGGetWord&
    temp0 = JPEGGetByte
    IF temp0 <> 1 AND temp0 <> 3 THEN GetSOS = 0: EXIT FUNCTION
    jpeg.numcomp = temp0
    FOR i = 1 TO temp0
     temp1 = JPEGGetByte
     SELECT CASE temp1
     CASE 1
      temp2 = JPEGGetByte
      jpeg.HaCTY = temp2 AND 15
      jpeg.HDCTY = temp2 \ 16
     CASE 2, 3
      temp2 = JPEGGetByte
      jpeg.HaCTcbr = temp2 AND 15
      jpeg.HDCTCBR = temp2 \ 16
     CASE ELSE
       PRINT "Images with "; temp1; " components not supported"
       EXIT FUNCTION
      
     END SELECT
    NEXT i
    d$ = JPEGgetstr$(3)
    IF (DCtables = 2 AND ACTAbles = 2 AND qtables = 2) OR jpeg.numcomp = 1 THEN
     'If we have all tables needed, exit and start displaying the image
     EXIT DO
    ELSE
     'else something is missing
     PRINT "Scan found before tables completed"
     EXIT FUNCTION
    END IF
  
   CASE &HDD                          'DRI: Define restart interval
    temp0 = JPEGGetWord&                  'some images have synch marks embedded..
    jpeg.restart = JPEGGetWord&           'we must skip them

   CASE &HDB                          'DQT: A quantization table. Read it
    IF qtables < 2 THEN
      l0 = JPEGGetWord&
      c0 = 2
      DO
       temp0 = JPEGGetByte: c0 = c0 + 1
       IF temp0 AND &HF0 THEN ERROR 105: END
       temp0 = temp0 AND 15
       FOR i = 0 TO 63
         quant(temp0, zz(i).xp, zz(i).yp) = JPEGGetByte: c0 = c0 + 1
       NEXT i
       qtables = qtables + 1
      LOOP UNTIL c0 >= l0
    ELSE
     PRINT "Can't handle more than 2 quantization tables"
     EXIT FUNCTION
    END IF
   CASE &HE0                          'APP0- application specific data
    l& = JPEGGetWord&                     'We are only interested in JFIF block
    IF JPEGgetstr$(5) <> ("JFIF" + CHR$(0)) THEN
      PRINT "JFIF header not found: Colorspace undefined. Can't decode it"
      EXIT FUNCTION
    END IF
    jpeg.jfifmajor = CHR$(JPEGGetByte)
    jpeg.jfifMinor = CHR$(JPEGGetByte)
    jpeg.densunits = CHR$(JPEGGetByte)
    jpeg.Xdens = JPEGGetWord&
    jpeg.ydens = JPEGGetWord&
    jpeg.ThWidth = CHR$(JPEGGetByte)
    jpeg.Theigth = CHR$(JPEGGetByte)
  
   CASE &HFE                          'COM a comment. Just read it
    imgcomment$ = JPEGgetstr$(JPEGGetWord& - 2)
  
   CASE &HE1 TO &HEF                  'APP1 to AP15  marker. Just skip it
     dummy$ = JPEGgetstr$(JPEGGetWord& - 2)
   CASE ELSE
   
   END SELECT
  END IF
  IF LEN(INKEY$) THEN EXIT FUNCTION
LOOP

'return 1 if succesful
JPEGGetParms = 1

END FUNCTION

FUNCTION JPEGgetstr$ (num)
  'gets an array of bytes from a JPEG file and returns them as a string
  JPEGgetstr$ = SPACE$(num)
  'I can't do a single GET as i'm using a buffered file access
  FOR i = 1 TO num
   MID$(JPEGgetstr$, i, 1) = CHR$(JPEGGetByte)
  NEXT
END FUNCTION

FUNCTION JPEGGetWord&
'gets a big endian word from the current position in file
temp = JPEGGetByte
JPEGGetWord& = 256& * temp + JPEGGetByte
END FUNCTION

SUB JPEGMakeHuffTree
'Called by JpegGetParams whenever it founds a Huffman table marker
'It reads Huffman table to an array then converts it into a binary
'tree (faster to access) and erase the table
'table used to store the Huffman tree values
'TYPE Huffmanentry               'a type for huffman tables
'  INDEX         AS LONG         'the output value
'  code          AS INTEGER      'searched value
'  size          AS INTEGER      'a size mask needed in search
'END TYPE

'TYPE Huffmantreeentry           'a type for huffman tree
'  code          AS INTEGER      'searched value
'  is1           AS INTEGER      'index to left branch
'  is0           AS INTEGER      'index to right branch
'END TYPE

'I patched the tree after the original routine. Probably the tree could be
' built while reading so everything could be simpler.



SHARED PwrsOf2() AS LONG

SHARED Hufftree()  AS Huffmantreeentry
SHARED huffstart()
SHARED ACTAbles, DCtables
SHARED tni, tindx

     l0 = JPEGGetWord&: c0 = 2
     'number of coefficients for each size
     REDIM huffamount(1 TO 16)
     DO
     
      'read a table
      temp0 = JPEGGetByte: c0 = c0 + 1
      tc = (temp0 AND 16) \ 16
      th = temp0 AND 15
      'PRINT t0, temp0: a$ = INPUT$(1)

      'read number of entries for each size
      total = 0
      FOR i = 1 TO 16
       temp1 = JPEGGetByte: c0 = c0 + 1
       total = total + temp1
       huffamount(i) = temp1
      NEXT i

      'read the codes into the array (huffamount(i) entries of 16 sizes)
      'the indexes are generated by an algorithm
      REDIM hufftbl(0 TO 256)  AS Huffmanentry
      curnum& = 0
      curindex = 0
      FOR i = 1 TO 16               'for each length
       FOR x = 1 TO huffamount(i)   'for the nr of codes in this length
        hufftbl(curindex).INDEX = curnum&
        hufftbl(curindex).code = JPEGGetByte: c0 = c0 + 1
        hufftbl(curindex).size = i
        curindex = curindex + 1
        curnum& = curnum& + 1
       NEXT x
       curnum& = curnum& * 2
      NEXT i

      'create huffman tree in a single array
      'hdebug = 1

      'save start of this tree
      huffstart(th * 2 + tc) = tni
      nxtfree = tni + 1

      IF hdebug THEN PRINT "nextfree"; nxtfree; tni
      'for each entry in table
      FOR i = 0 TO curindex - 1
        s = hufftbl(i).size
        'left align index
        xx& = hufftbl(i).INDEX
        ptr = tni
        IF hdebug THEN
            PRINT "table entry num"; i; "code"; hufftbl(i).code;
            a$ = fnb$(xx&)
            PRINT "size "; s; "index"; hufftbl(i).INDEX, xx&, RIGHT$(a$, 16)
        END IF
        'for each bit in entry
        FOR bit = s - 1 TO 0 STEP -1
            IF hdebug THEN PRINT "next bit"; ptr, bit, (xx& AND PwrsOf2(bit))
            'if bit is 1
            IF xx& AND PwrsOf2(bit) THEN
                nxt = Hufftree(ptr).is1
                'next exists
                IF nxt THEN
                    IF hdebug THEN PRINT "..1"; ptr, nxt
                    ptr = nxt
                'don't exist, create it
                ELSE
                   IF hdebug THEN PRINT "new1"; ptr, nxtfree
                    Hufftree(ptr).is1 = nxtfree
                    ptr = nxtfree: nxtfree = nxtfree + 1
                END IF
            'ti bit is 0
            ELSE
                nxt = Hufftree(ptr).is0
                'next exists
                IF nxt THEN
                    IF hdebug THEN PRINT "..0"; ptr, nxt
                    ptr = nxt
                'don't exist, create it
                ELSE
                    IF hdebug THEN PRINT "new0"; ptr, nxtfree
                    Hufftree(ptr).is0 = nxtfree
                    ptr = nxtfree: nxtfree = nxtfree + 1
                END IF
            END IF
        NEXT 'x
        IF hdebug THEN
            PRINT "branch ended "; ptr; " code "; hufftbl(i).code
            PRINT
            a$ = INPUT$(1)
        END IF
        'set code at the end of tree
        Hufftree(ptr).code = hufftbl(i).code
      NEXT i
      tni = ptr + 2: tindx = tindx + 1
      IF hdebug THEN PRINT "************tni"; tni: PRINT : PRINT
      'go for the new table
      IF tc THEN ACTAbles = ACTAbles + 1 ELSE DCtables = DCtables + 1
     LOOP UNTIL c0 >= l0
     IF hdebug THEN a$ = INPUT$(1)
     ERASE hufftbl, huffamount
EXIT SUB


'DEBUGGING
debughuff:
    FOR i = -1 TO 47
    PRINT USING "###  ###  \             \ ### ### #####"; i; hufftbl(i).code; fnb$(hufftbl(i).code); hufftbl(i).INDEX
    NEXT
    a$ = INPUT$(1)
RETURN

END SUB

FUNCTION JPEGRenderColor (jfile, x0, y0)
'JPEGGetParams exits when  a SOF marker is found.Then the main loop sets a
' SVGA mode and this routine (or the mono one) is called.

'JPEGRenderColor calls decoder for each block, combines them and sends pixels to
' screen. It skips Restart markers,checks for screen boundaries,selects
' svga banks and draw pixels.
' If an image mcu is outside the top, left or right boundaries of the
' screen, its blocks are just Huffman decoded, IDCT is skipped. viw flag
' controls it. When the bottom of the screen is reached, decoding is just
' stopped.

SHARED vesainfo AS vesainfoblock
SHARED buf2ptr AS INTEGER, viw AS INTEGER
SHARED jpeg AS JpegType

SHARED rcrv(), gcbv(), gcrv(), bcbv()
SHARED rgb() AS INTEGER



'vectors save the 8x8 blocks returned bu JPEGGet8x8, to be combined in an
' image mcu

REDIM YVector1(0 TO 7, 0 TO 7)              '4 vectors for Y attribute
REDIM YVector2(0 TO 7, 0 TO 7)
REDIM YVector3(0 TO 7, 0 TO 7)
REDIM YVector4(0 TO 7, 0 TO 7)
REDIM CbVector(0 TO 7, 0 TO 7)              '1 vector for Cb attribute
REDIM CrVector(0 TO 7, 0 TO 7)              '1 vector for Cr attribute

REDIM rgb(0 TO 2, 0 TO 15, 0 TO 15) AS INTEGER

  'We initialize the dc coefficients for each component
  'at start and at each restart mark: they are cumulative
 
  dcY = 0: dcCb = 0: dcCr = 0
  'indexes to the image
  xindex = 0: yindex = 0
  'huffman decoder buffer ptr
  buf2ptr = 0
  'mcu counter. Used only if restart marks present
  mcu = 0
 
  'set parameters for 2x2. 2x1, 1x2 ,1x1 files
  SELECT CASE jpeg.samplesyx
  CASE 2:
  IF jpeg.samplesyy = 2 THEN
    xinc = 16: yinc = 16: nsy = 4
  ELSE
    xinc = 16: yinc = 8: nsy = 2
  END IF
  CASE 1:
  IF jpeg.samplesyy = 2 THEN
    xinc = 8: yinc = 16: nsy = 2
  ELSE
    xinc = 8: yinc = 8: nsy = 1
  END IF
  CASE ELSE
    ERROR 101
  END SELECT
 
  'Init limits to be passed to SVGAPutBlock
  xrend = xinc - 1: yrend = yinc - 1

  'rendering loop
  DO                                     'for each mcu
    'check if present mcu  is fully off screen limits,set viw flag
    'if so we will only partially decode it and will not try to display it
    viw = -1
    xi0 = xindex + x0
    IF xi0 >= vesainfo.xres THEN
     viw = 0
    ELSEIF xi0 < 0 THEN
     viw = 0
    ELSEIF (yindex + y0) < 0 THEN
     viw = 0
    END IF
        
    'get next blocks from decoder
    SELECT CASE nsy
    CASE 4:
      JPEGGet8x8 YVector1(), 1, dcY
      JPEGGet8x8 YVector2(), 1, dcY
      JPEGGet8x8 YVector3(), 1, dcY
      JPEGGet8x8 YVector4(), 1, dcY
    CASE 2:
      JPEGGet8x8 YVector1(), 1, dcY
      JPEGGet8x8 YVector2(), 1, dcY
    CASE 1:
      JPEGGet8x8 YVector1(), 1, dcY
    END SELECT
       
    JPEGGet8x8 CbVector(), 2, dcCb
    JPEGGet8x8 CrVector(), 2, dcCr
             
    'viw is a shared flag: 1 means the present block has to be displayed
    'it's initialized in the main loop
    'viw = 1
    IF viw THEN 'display the image mcu
               
      'proceed line by line to minimize bank switching
      FOR y = 0 TO yinc - 1
                 
        'if past the bottom border of the image, go for a new mcu
        yi = yindex + y: IF yi >= jpeg.rows THEN EXIT FOR
        'if past the bottom of screen, go for a new mcu
        'IF yi > ylim THEN EXIT FOR
                 
        'calculate index in CB/CR blocks
        y2 = y \ 2
                 
        FOR x = 0 TO xinc - 1              'for each pixel in line in mcu
                   
          'get Y component of the pixel from the two bottom blocks if y>=8

          IF y AND 8 THEN
            IF x AND 8 THEN
              yyy = YVector4(y AND 7, x AND 7) + 128
            ELSE
              yyy = YVector3(y AND 7, x) + 128
            END IF
          'else get it from the top blocks
          ELSE
            IF x AND 8 THEN
              yyy = YVector2(y, x AND 7) + 128
            ELSE
              yyy = YVector1(y, x) + 128
            END IF
          END IF
                   
          'Go get Cb AND cr, convert to rgb and plot pixel
          j2 = x \ 2: crv = CrVector(y2, j2): cbv = CbVector(y2, j2)
         
          'convert Y-CR-CV to RGB
          R = yyy + rcrv(crv)
          g = yyy + gcbv(cbv) + gcrv(crv)
          b = yyy + bcbv(cbv)
         
          'clip RGV values
          IF R > 255 THEN
           R = 255
          ELSEIF R < 0 THEN
           R = 0
          END IF
         
          IF g > 255 THEN
           g = 255
          ELSEIF g < 0 THEN
           g = 0
          END IF
         
          IF b > 255 THEN
           b = 255
          ELSEIF b < 0 THEN
           b = 0
          END IF
         
          rgb(0, x, y) = R: rgb(1, x, y) = g: rgb(2, x, y) = b

        NEXT x                         'next pixel in line in mcu
        
      NEXT y                           'next line in the mcu
      
      'display mcu
      SVGAPutBlock xindex + x0, yindex + y0, xrend, yrend

    END IF                             'if mcu must be displayed
            
    'if image has restart marks, keep counting nr of elements (mcu)
    IF jpeg.restart THEN
       mcu = mcu + 1
       'if restart interval reached skip restart mark and reset DC components
       IF jpeg.restart = mcu THEN
        buf2ptr = (buf2ptr AND &HFFF8) - 16
        dcY = 0: dcCb = 0: dcCr = 0: mcu = 0
       END IF
    END IF
             
    'move right the graphics cursor to next mcu
    xindex = xindex + xinc
    IF jpeg.cols - xindex < xinc THEN
      xrend = jpeg.cols - xindex - 1
    ELSE
     xrend = xinc - 1
    END IF
    'if right side of image reached, go for next mcu row of mcu's
    IF xindex >= jpeg.cols THEN
      xindex = 0: xrend = xinc - 1
      yindex = yindex + yinc
      IF jpeg.rows - yindex < yinc THEN
        yrend = jpeg.rows - yindex - 1
      ELSE
       yrend = yinc - 1
      END IF
      'return -1 if escaped
      IF LEN(INKEY$) THEN JPEGRenderColor = -1: EXIT DO
    END IF
           
    'stop if no more mcu's or bottom of  screen reached
  LOOP UNTIL yindex >= jpeg.rows OR yindex + y0 >= vesainfo.yres
 
  'kindly free memory for other uses
  ERASE YVector1, YVector2, YVector3, YVector4, CbVector, CrVector, rgb
  buf$ = ""
END FUNCTION

FUNCTION JPEGRenderMono (jfile, x0, y0)
  'monochrome jpeg. This is easy, we have only the Y component, Image elements
  'are 8X8, the same as blocks
 
SHARED vesainfo AS vesainfoblock
SHARED buf2ptr AS INTEGER, viw AS INTEGER
SHARED jpeg AS JpegType

SHARED CurBank AS INTEGER

SHARED yseg(), ybank()
SHARED Offset
SHARED xoff()
SHARED rgb() AS INTEGER
SHARED Regs AS regtypeX
'vectors save the 8x8 blocks returned bu JPEGGet8x8, to be combined in an
' image mcu

REDIM YVector1(0 TO 7, 0 TO 7)              '4 vectors for Y attribute
REDIM rgb(0, 0 TO 7, 0 TO 7)  AS INTEGER

  'We initialize the dc coefficients for each component
  'at start and at each restart mark: they are cumulative

  dcY = 0: dcCb = 0: dcCr = 0
  xindex = 0: yindex = 0
  buf2ptr = 0
  mcu = 0
  xlim = vesainfo.xres - x0
  ylim = vesainfo.yres - y0
  xrend = 7: yrend = 7
DO
  'check if present mcu  is fully off screen limits,set viw flag
  'if so we will only partially decode it and will not try to display it
  viw = -1
  xi0 = xindex + x0
  IF xi0 >= vesainfo.xres THEN
   viw = 0
  ELSEIF xi0 < 0 THEN
   viw = 0
  ELSEIF (yindex + y0) < 0 THEN
   viw = 0
  END IF
    

  'go decode a block
  JPEGGet8x8 YVector1(), 1, dcY
    
  'If block must be viewed, display it
  IF viw THEN
    'for each line
    FOR y = 0 TO 7
        
      'if line below the bottom of jpeg go for a new block
      yi = yindex + y: IF yi >= jpeg.rows THEN EXIT FOR
     
      'for each pixel in line
      FOR x = 0 TO 7
        'if pixel  past right border of image go for a new line
        xj = xindex + x: IF xj >= jpeg.cols THEN EXIT FOR
       
        'get Y value for present pixel
        yyy = YVector1(y, x) + 128
        'clip it
        IF yyy < 0 THEN
          yyy = 0
        ELSEIF y > 255 THEN
          yyy = 255
        END IF
        rgb(0, x, y) = yyy
      NEXT x  'next pixel in line
    NEXT y    'next line
    'display mcu
    SVGAPutBlockBW xindex + x0, yindex + y0, xrend, yrend

  END IF      'mcu was to be displayed
    
  'if image has restart marks, keep counting nr of elements
  'if restart interval reached skip restart mark and reset DC components
    IF jpeg.restart THEN
       mcu = mcu + 1:
       IF jpeg.restart = mcu THEN
        buf2ptr = (buf2ptr AND &HFFF8) - 16
        dcY = 0: dcCb = 0: dcCr = 0: mcu = 0
       END IF
    END IF
    
    'move right the graphics cursor to next mcu
    xindex = xindex + 8
    IF jpeg.cols - xindex < 8 THEN
      xrend = jpeg.cols - xindex - 1
    ELSE
     xrend = 7
    END IF
    'if right side of image reached, go for next mcu row of mcu's
    IF xindex >= jpeg.cols THEN
      xindex = 0: xrend = 7
      yindex = yindex + 8
      IF jpeg.rows - yindex < 8 THEN
        yrend = jpeg.rows - yindex - 1
      ELSE
       yrend = 7
      END IF
      'return -1 if escaped
      IF LEN(INKEY$) THEN JPEGRenderMono = -1: EXIT DO
    END IF
'if at bottom of the image or screen, stop decoding
LOOP UNTIL yindex >= jpeg.rows OR yindex + y0 >= vesainfo.yres
'be kind and free memory for other uses
 
ERASE YVector1, rgb
buf$ = ""

END FUNCTION

SUB JPEGViewParms
 'displays the info the JPEGGetParms has read from JPEG header

 SHARED f$
 SHARED imgcomment$
 SHARED jpeg AS JpegType
 PRINT "Parameters of this JPEG File"
 PRINT
 PRINT "File Name            :  "; f$
 PRINT USING "File  size           : ######,###               bytes"; jpeg.size
 PRINT "Comment              : "; imgcomment$
 PRINT USING "JFIF Format Version  :         ##     .    ##"; ASC(jpeg.jfifmajor); ASC(jpeg.jfifMinor)
 PRINT USING "Rows X Cols          :       ####     x  ####   pixel ##.## Mpixel"; jpeg.rows; jpeg.cols; CSNG(jpeg.rows) * jpeg.cols / 1000000!
 temp& = 3& * jpeg.rows * jpeg.cols
 PRINT USING "Uncompressed size    : ######,###               bytes"; temp&
 PRINT USING "Compression ratio    :       ####.#   to    1"; temp& / jpeg.size
 SELECT CASE ASC(jpeg.densunits)
 CASE 0: unit$ = "ratio"
 CASE 1: unit$ = "dots/inch"
 CASE 2:  unit$ = "dots/cm"
 CASE ELSE
 END SELECT
 PRINT USING "Density           X/Y:       ####     /  ####   \        \"; jpeg.Xdens; jpeg.ydens; unit$
 IF jpeg.restart THEN
 PRINT USING "Restart each         :      #####               blocks"; jpeg.restart
 ELSE
 PRINT "No Restart marks in this file"
 END IF
 PRINT USING "Thumbnail w x h      :        ###     x   ###   pixel "; ASC(jpeg.ThWidth); ASC(jpeg.Theigth)
 IF jpeg.numcomp = 3 THEN a$ = " Color Y + Cb + Cr" ELSE a$ = " Black & White"
 PRINT "Color components     : "; a$
 PRINT USING "Samples  Y x: #  y: #   CBCR    x: #  y: #"; jpeg.samplesyx; jpeg.samplesyy; jpeg.samplescbcrx; jpeg.samplescbcry
 PRINT
 PRINT "Quantization tables Y: "; jpeg.qty + 1; : LOCATE , 49: PRINT "Cbcr: "; jpeg.qtcbr - jpeg.qty
 PRINT "Huffman tables DC   Y: "; jpeg.HDCTY + 1; : LOCATE , 49: PRINT "CbCr: "; jpeg.HDCTCBR - jpeg.HDCTY
 PRINT "Huffman tables aC   Y: "; jpeg.HaCTY + 1; : LOCATE , 49: PRINT "CbCr: "; jpeg.HaCTcbr - jpeg.HaCTY
 PRINT

END SUB

SUB menu
 'displays main menu and some timings
 SHARED marker$
 SHARED vesainfo AS vesainfoblock
 SHARED time!, bltime!, nofast
 IF nofast THEN a$ = "NN&M" ELSE a$ = "AA&N"
 FOR i = 1 TO LEN(marker$)
    PRINT HEX$(ASC(MID$(marker$, i, 1))); " ";
 NEXT
 PRINT
 PRINT "      MENU"
 PRINT "      ===="
 PRINT
 PRINT "      F:  select new JPEG File"
 PRINT "      V:  View JPEG"
 PRINT "      M:  change SVGA mode"
 PRINT "      A:  Change IDCT algorithm. Now using: "; a$
 PRINT "      X:  eXit program"
 PRINT
 PRINT "      Present SVGA mode is:"
 PRINT USING "      MODE \ \H  #### x #### x ## "; HEX$(vesainfo.modenum); vesainfo.xres; vesainfo.yres; vesainfo.bpp
 PRINT
 PRINT USING "      Last Decoding time: ####.## sec "; time!

END SUB

FUNCTION SelectAFile$ (header$, ext$)
'
' DANGER: Spaghetti code!! Don't port! Not commented....
'
' User friendly file selector routine.Returns full path of a file
' by Antoni Gual agual@eic.ictnet.es
' Fully reprogrammed from a layout by William Yu
'
' Use as you want, only give me credit
'
' FEATURES:
' Should not display DOS error messages when disk not ready
' Tested in Win 95/98 and  DOS 6.1-Win 3.11.
' Auto detects num of screen lines set by main program.
' Tested with QBasic
' Not self contained, needs DiskReady and DetectWinTemp routines!
' No mouse!
' In W95/98 displays LFN, but returns 8.3 format
'   (QB file functions can't handle LFN)
'
' REMARKS:
' For non Win 9x users: It Runs faster if temp path is set to a RAM drive!
' Creates some auxiliar files: To do it, uses path in temp system variable
' To use it with DOS < 5.0 try changing constant DOS to 3 (Sorry..I.Can't test it)
' To avoid drive checking each time the routine is run, read comment
'    6 lines above EXIT FUNCTION
'
'-------------------------------------------------------------------------
 'PUT DOS TO 3 IF THE PROGRAM HAS TO RUN UNDER DOS BELOW 5.0
 DIM z$
 SHARED win, temppath$
 CONST dos = 5


 'keys
 CONST kpgup = -&H49, kpgdn = -&H51
 CONST kleft = -&H4B, kright = -&H4D, kup = -&H48, kdown = -&H50
 CONST kenter = &HD, kesc = &H1B

 q$ = CHR$(34)

 'colors
 CONST fgiuns = 7, bgiuns = 0, fgauns = 15, bgauns = 0
 CONST fgisel = 12, bgisel = 0, fgasel = 15, bgasel = 4

 'auxiliar files
 DIM auxf$(1 TO 3):
 auxf$(3) = temppath$ + "}{drive.lst": auxf$(2) = temppath$ + "}{dir.lst"
 auxf$(1) = temppath$ + "}{file.lst"
 tempfile$ = temppath$ + "temp.txt"

 'Detect Nr of lines of screen
 DEF SEG = &H40
 scrl = PEEK(&H84) + 1
 DEF SEG

 DIM wd(0 TO 4, 1 TO 3)
 'vertical window sizes
 CONST wintop = 8
 winbot = scrl - 7: winheight = winbot - wintop + 1

 'indexs ( they avoid for a type definition in the main module)
 CONST wdxpos = 0, wdwdth = 1, wdtop = 2, wdcur = 3, wdcount = 4


 'init
 wd(wdxpos, 1) = 8: wd(wdxpos, 2) = 38: wd(wdxpos, 3) = 68
 IF win THEN
  wd(wdwdth, 1) = 24: wd(wdwdth, 2) = 24: wd(wdwdth, 3) = 6
 ELSE
  wd(wdwdth, 1) = 12: wd(wdwdth, 2) = 8: wd(wdwdth, 3) = 6
 END IF
 wd(wdtop, 1) = 1: wd(wdtop, 2) = 1: wd(wdtop, 3) = 1


 'strings with windows width
 DIM t$(1 TO 3): FOR i = 1 TO 3: t$(i) = SPACE$(wd(wdwdth, i)): NEXT
 h$ = SPACE$(64)


 'prepare command strings
 IF dos = 5 THEN
  IF win THEN x$ = " /Z"
   dosdirs$ = "DIR  /AD /ON /B >>" + auxf$(2)
     dosfiles$ = "DIR *." + ext$ + " /A-D /ON /B >" + auxf$(1)
 ELSE
  dosdirs$ = "DIR *.* |FIND " + q$ + "<DIR>" + q$ + " >" + auxf$(2)
  dosfiles$ = "DIR *." + ext$ + " | FIND " + q$ + ":" + q$ + "|FIND /V " + q$
  dosfiles$ = dosfiles$ + "<DIR>" + q$ + "|FIND /V " + q$ + ":\" + q$ + " >" + auxf$(1)
 END IF

 temp = INSTR(ext$, "."): IF temp THEN ext$ = MID$(ext$, temp + 1)

 'check all possible drives and build a drive list
 file$ = auxf$(3): GOSUB filexist
 IF exist = false THEN
  f = FREEFILE: OPEN auxf$(3) FOR OUTPUT AS #f
  COLOR 7, 0: CLS : PRINT "Checking existing drives: please wait!"
  FOR i = ASC("A") TO ASC("Z")
   IF DiskReady(CHR$(i)) <> 2 THEN
    LSET t$(3) = "-[" + CHR$(i) + ":]-"
    PRINT #f, t$(3)
   END IF
  NEXT
  CLOSE #f
 END IF
 f = FREEFILE: OPEN auxf$(3) FOR INPUT AS #f
 w1 = 3: GOSUB ITEMCOUNT
 CLOSE f

 'init screen
 SCREEN 0: COLOR 7, 1: CLS
 COLOR 14: LOCATE 1, 40 - LEN(header$) \ 2: PRINT header$;
 'top rectangle
 LOCATE 3, 4: COLOR 9, 0: PRINT CHR$(218); STRING$(72, 196); CHR$(191)
 LOCATE 4, 4: PRINT CHR$(179); STRING$(72, 0); CHR$(179)
 LOCATE 5, 4: PRINT CHR$(192); STRING$(72, 196); CHR$(217)

 'other rectangles
 FOR x1 = 1 TO 3: GOSUB rect: NEXT
 COLOR 14, 1: LOCATE scrl - 2, 2
 PRINT "Up/Dn Pgup/PgDn Move cursor, Left/Right Change Panel, Enter Select, Esc Quit";

 'clear keyboard buffer
 WHILE LEN(INKEY$): WEND

 'init drive an dir cursor
 GOSUB curdir

 'cursor will start in files window
 actwin = 1

 'here we enter the main loop
updatedrive:
 f = FREEFILE: OPEN auxf$(3) FOR INPUT AS #f
  w1 = 3: GOSUB updatewin
 CLOSE f

'update dir list
updatedir:

 GOSUB curdir
 IF dos = 5 THEN
  f = FREEFILE: OPEN auxf$(2) FOR OUTPUT AS #f
  IF LEN(curdir$) > 3 THEN PRINT #f, ".."
  CLOSE f
 END IF

 SHELL dosdirs$

 OPEN auxf$(2) FOR INPUT AS #f
  w1 = 2: GOSUB ITEMCOUNT: GOSUB updatewin
 CLOSE f

 'update file list
 SHELL dosfiles$
 f = FREEFILE: OPEN auxf$(1) FOR INPUT AS #f
  w1 = 1: GOSUB ITEMCOUNT: GOSUB updatewin
  IF wd(wdcount, 1) = 0 THEN actwin = 2: w1 = 2: GOSUB updatewin
 CLOSE f

'keys loop
'program will stay in this loop unless window change or press enter or esc
movecursor:
 w1 = actwin
 OPEN auxf$(actwin) FOR INPUT AS #f
 DO
  GOSUB updatewin
  DO: v$ = INKEY$: LOOP UNTIL LEN(v$)
  v = ASC(RIGHT$(v$, 1)): IF ASC(v$) = 0 THEN v = -v
  SELECT CASE v
  CASE kup:
    wd(wdcur, w1) = wd(wdcur, w1) - 1
    IF wd(wdcur, w1) < 1 THEN wd(wdcur, w1) = 1
  CASE kdown:
    wd(wdcur, w1) = wd(wdcur, w1) + 1
    IF wd(wdcur, w1) > wd(wdcount, w1) THEN wd(wdcur, w1) = wd(wdcount, w1)
  CASE kpgup:
    wd(wdcur, w1) = wd(wdcur, w1) - winheight
    IF wd(wdcur, w1) < 1 THEN wd(wdcur, w1) = 1
  CASE kpgdn:
    wd(wdcur, w1) = wd(wdcur, w1) + winheight
    IF wd(wdcur, w1) > wd(wdcount, w1) THEN wd(wdcur, w1) = wd(wdcount, w1)
  'change active window
  CASE kleft:
   IF actwin > 1 THEN
      IF actwin <> 2 OR wd(wdcount, 1) > 0 THEN
    actwin = actwin - 1: GOSUB updatewin: CLOSE #f: GOTO movecursor
      END IF
   END IF
  'change active window
  CASE kright:
   IF actwin < 3 THEN
    actwin = actwin + 1: GOSUB updatewin: CLOSE #f: GOTO movecursor
   END IF
  'select file in file window, change dir or drive in other windows
  CASE kenter:
   WHILE DiskReady(newdrive$) = 1
    err$ = "Disk " + newdrive$ + " not ready   [R]etry/[C]ancel?": GOSUB errmsg
    IF a$ <> "R" THEN CLOSE f: SHELL "C:": GOTO updatedrive
   WEND
   SELECT CASE actwin
   'select file and exit
   CASE 1:
    IF LEN(newfile$) THEN
     CLOSE f: tmp$ = curdir$ + newfile$
     IF win THEN
      'truename fails with filenames so i use it only with dir name
      doscmd$ = "TRUENAME |find " + q$ + ":\" + q$ + ">" + tempfile$
      SHELL doscmd$
      OPEN tempfile$ FOR INPUT AS f: LINE INPUT #f, tp$: CLOSE f
      tmp$ = tp$: IF LEN(tmp$) > 3 THEN tmp$ = tmp$ + "\"
      KILL tempfile$
      doscmd$ = "DIR /A-D " + q$ + newfile$ + q$ + "|FIND " + q$ + ":" + q$ + "|FIND /V " + q$ + ":\" + q$ + ">" + tempfile$
      SHELL doscmd$
      OPEN tempfile$ FOR INPUT AS f: LINE INPUT #f, tp$: CLOSE f
      t$ = SPACE$(12): LSET t$ = tp$: MID$(t$, 9) = "."
      tmp$ = tmp$ + RTRIM$(t$)
     END IF
     SelectAFile$ = tmp$: EXIT DO
    ELSE
     actwin = actwin + 1: GOSUB updatewin
    END IF
   'change dir
   CASE 2:
    IF newdir$ <> "." THEN
     IF (LEN(curdir$) > 3) OR (newdir$ <> "..") THEN
      CLOSE f: SHELL "CD " + newdir$: GOTO updatedir
     END IF
    END IF
   'change drive
   CASE 3:
     CLOSE f: SHELL newdrive$: GOTO updatedrive
   CASE ELSE
   END SELECT
  CASE kesc:
   CLOSE #f: SelectAFile$ = "": EXIT DO
  CASE ELSE
  END SELECT
 LOOP
 KILL auxf$(1)
 KILL auxf$(2)
 'KILL auxf$(3) 'this file (}{drive.lst) keeps the list of valid drives
 '              to avoid drive testing each time the routine is run
 '              put a REM in  this line and erase the file at program's end.
 '              (Or don't erase it, if your drives are all fixed)
 IF win THEN z$ = q$ ELSE z$ = ""
 CLS
EXIT FUNCTION

'---------------------------gosubs------------------------------------------
'update window W1 from the contents of already opened file f
updatewin:
 SEEK #f, 1
 IF actwin = w1 THEN isactive = true ELSE isactive = false
 IF wd(wdcur, w1) < wd(wdtop, w1) THEN wd(wdtop, w1) = wd(wdcur, w1)
 IF wd(wdcur, w1) > (wd(wdtop, w1) + winheight - 1) THEN wd(wdtop, w1) = wd(wdcur, w1) - winheight + 1
 i = 1: x = wintop: k = wd(wdleft, w1)
 WHILE NOT EOF(f) AND x <= winbot
  LINE INPUT #f, a$
  IF i >= wd(wdtop, w1) THEN
   LSET t$(w1) = a$
   IF i = wd(wdcur, w1) THEN
    IF isactive THEN COLOR fgasel, bgasel ELSE COLOR fgisel, bgisel
    SELECT CASE w1
     CASE 1: newfile$ = RTRIM$(a$)
     'IF LEN(NEWFILE$) > 9 THEN MID$(NEWFILE$, 9) = "."
     CASE 2: newdir$ = RTRIM$(a$): IF win THEN newdir$ = q$ + newdir$
     CASE 3: newdrive$ = MID$(t$(w1), 3, 2)
    END SELECT
   ELSE
    IF isactive THEN COLOR fgauns, bgauns ELSE COLOR fgiuns, bgiuns
   END IF
   LOCATE x, k: PRINT t$(w1); : x = x + 1
  END IF
  i = i + 1
 WEND
 LSET t$(w1) = "": COLOR fgiuns, bgiuns
 FOR j1 = x TO winbot
    LOCATE j1, k: PRINT t$(w1)
 NEXT
RETURN

curdir:
 tempfile$ = temppath$ + "curr.dir"
 SHELL "CD > " + tempfile$
 f = FREEFILE: OPEN tempfile$ FOR INPUT AS #f
 LINE INPUT #f, curdir$
 IF LEN(curdir$) <> 3 THEN curdir$ = curdir$ + "\"
 curdrive$ = LEFT$(curdir$, 1)
 CLOSE f: KILL tempfile$
 OPEN auxf$(3) FOR INPUT AS #f
  i = 0
  DO: i = i + 1: LINE INPUT #f, a$: LOOP UNTIL INSTR(a$, curdrive$)
 CLOSE f
 wd(wdcur, 3) = i
 LSET h$ = curdir$ + "*." + ext$
 LOCATE 4, 6: COLOR 10: PRINT h$;
RETURN


'GUI: draw a shadowed rectangle, dimensions in wd(?,x1)
rect:
 COLOR 9, 7: LOCATE wintop - 1, wd(wdxpos, x1) - 1
 PRINT CHR$(218); STRING$(wd(wdwdth, x1), 196); CHR$(191)
 FOR x = wintop TO winbot
   LOCATE x, wd(wdxpos, x1) - 1
   PRINT CHR$(179); STRING$(wd(wdwdth, x1), 32); CHR$(179)
 NEXT x
 LOCATE winbot + 1, wd(wdxpos, x1) - 1
 PRINT CHR$(192); STRING$(wd(wdwdth, x1), 196); CHR$(217)
 FOR x = wintop TO winbot + 1
  LOCATE x, wd(wdxpos, x1) + wd(wdwdth, x1) + 1: COLOR 0
  PRINT STRING$(2, 219)
 NEXT x
 LOCATE winbot + 2, wd(wdxpos, x1) + 2: PRINT STRING$(wd(wdwdth, x1) + 1, 219)
RETURN

'check if a file exists
filexist:
 f = FREEFILE: OPEN file$ FOR BINARY AS #f
 IF LOF(f) = 0 THEN exist = false: CLOSE #f: KILL file$ ELSE exist = true: CLOSE #f
RETURN

'count items in list file
ITEMCOUNT:
 x = 0: WHILE NOT EOF(f): LINE INPUT #f, a$: x = x + 1: WEND
 wd(wdcount, w1) = x: wd(wdcur, w1) = 1
RETURN

'displays an eror message and waits for a key
errmsg:
 LSET h$ = err$
 LOCATE 4, 6: COLOR 12: PRINT h$;
 a$ = UCASE$(INPUT$(1)): LSET h$ = "": LOCATE 4, 6: PRINT h$
RETURN

END FUNCTION

SUB svgacheckmode (x, md&)
'This is a SUB of SVGAModeSelector 
'For a SVGA mode checks if there is enough memory for an optimized line length
'then checks if present jpeg fits in, a the end it builds a descriptive string
'into the mode list array
'
SHARED vesainfo AS vesainfoblock
SHARED display AS vesaModeinfoBlock
SHARED jpeg AS JpegType
SHARED modes() AS VESAsorttype
CONST frmt$ = "-! MODE \ \H  #### x #### x ##"
 
  bytespixel = (ASC(display.bpp) + 7) \ 8
  IF bytespixel = 3 THEN factor = 4096 ELSE factor = 128
  a = 1
  a1 = bytespixel * display.xres
  DO UNTIL a * factor >= a1: a = a * 2: LOOP
  linelen& = a * factor
  IF vesainfo.totalmemory * 65536 < linelen& * display.yres THEN EXIT SUB
  jfit$ = " "
  IF jpeg.cols <= display.xres AND jpeg.rows <= display.yres THEN jfit$ = "*"
  modes(x).MODE = md&
  modes(x).INDEX = (display.xres \ 10) * 100000 + (display.yres \ 10) * 100 + ASC(display.bpp)
 
  'Format output into an array
  'An useful trick from Ethan Winer's book
  'A dummy file NUL must be opened and closed for each new string
 
  NUL = FREEFILE: OPEN "\DEV\NUL" FOR RANDOM AS #NUL LEN = 255
  PRINT #NUL, USING frmt$; jfit$; HEX$(md&); display.xres; display.yres; ASC(display.bpp)
  LINE INPUT #NUL, b$: LSET modes(x).CAPTION = b$
  CLOSE NUL
  x = x + 1
END SUB

SUB SVGAGetModeInfo (md&)
  'reads from VESA API the parameters of a SVGA mode

  SHARED display AS vesaModeinfoBlock
  SHARED Regs AS regtypeX
  Regs.ax = &H4F01
  Regs.cx = md&
  Regs.es = VARSEG(display)
  Regs.DI = VARPTR(display)
  CALL INTERRUPTy(&H10, Regs)
END SUB

SUB SVGAInit
'get general data from the VESA API
'If no VESA detected program is stopped

SHARED vesainfo AS vesainfoblock
SHARED Regs AS regtypeX
CONST VESAOK = &H4F
Regs.ax = &H4F00
Regs.es = VARSEG(vesainfo)
Regs.DI = VARPTR(vesainfo)
CALL INTERRUPTy(&H10, Regs)
IF Regs.ax <> VESAOK THEN PRINT "SORRY...VESA CARD NOT DETECTED": END

'Get amount of modes so SVGASelectMode can dimension an array
'Valid modes are checked each time SVGASelectMode is called
a$ = MKL$(vesainfo.VIDEOMODEPTR)
DEF SEG = vesainfo.VIDEOMODESEG
 ptr1 = vesainfo.VIDEOMODEPTR
 i = 0
 DO UNTIL md& = 65535
  i = i + 1
  temp = PEEK(ptr1)
  ptr1 = ptr1 + 1
  md& = PEEK(ptr1) * 256& + temp
  ptr1 = ptr1 + 1
 LOOP
DEF SEG
vesainfo.modemax = i - 1
END SUB

SUB SVGAPRINT (t$, xstartpos, ystartpos, scrxsize, scrysize, chspacing, font)

'Uses ROM fonts (this can be changed easily) to display a scalable size text
'in the current SVGA mode. It proceeds line by line, not char by char
'so it should be fast.

'CAUTION: It does'nt check for out of screen conditions!

'positions and sizes in pixels!
'ROM font numbers valid:
' font 2: 14 pixel high x 8
' font 3: 8  pixel high x 8
' font 6: 16 pixel high x 8

SHARED Regs AS regtypeX
SHARED PwrsOf2() AS LONG
SHARED rlook(), glook(), blook(), g2look()
SHARED xoff(), yseg(), ybank()
SHARED vesainfo AS vesainfoblock
SHARED CurBank AS INTEGER
IF LEN(t$) = 0 THEN EXIT SUB

REDIM t1a&(LEN(t$)), ta(LEN(t$)), oa&(LEN(t$)), ea&(LEN(t$))
STATIC Fontseg, fontoffset&, lf, chysize, chxsize, R, g, b
'locate charmap in bios
        IF lf <> font THEN
                'change this block if you want to use a font in an array
                chxsize = 8
                SELECT CASE font:
                CASE 2: chysize = 14
                CASE 3: chysize = 8
                CASE 6: chysize = 16
                CASE ELSE: EXIT SUB
                END SELECT
                R = 255: g = 255: b = 255

                Regs.ax = &H1130
                Regs.bx = font * 256
                CALL INTERRUPTy(&H10, Regs)
                Fontseg = Regs.es
                fontoffset& = Regs.bp
                lf = font
        END IF

        oa&(0) = (Xchstart - scrxsize - chspacing) * vesainfo.bytespixel
        FOR strptr = 1 TO LEN(t$)
           t1a&(strptr) = fontoffset& + ASC(MID$(t$, strptr)) * chysize
           oa&(strptr) = oa&(strptr - 1) + CLNG(vesainfo.bytespixel) * (scrxsize + chspacing)
           ea&(strptr) = oa&(strptr) + vesainfo.bytespixel * (scrxsize - 1)
        NEXT
        YEndPos = ystartpos + scrysize - 1
        ystep = chysize - 1
        xstep = chxsize - 1
        Ycounter = -scrysize: chbyteptr = 0: lyptr = chbyteptr - 1
        'bresenham*2
        DEF SEG = Fontseg
        FOR strptr = 1 TO LEN(t$)
          ta(strptr) = PEEK(t1a&(strptr) + chbyteptr)
        NEXT
        FOR pixely = ystartpos TO YEndPos

                IF ybank(pixely) <> CurBank THEN
                    Regs.ax = &H4F05
                    Regs.bx = 0
                    Regs.dx = ybank(pixely)
                    CALL INTERRUPTy(&H10, Regs)
                    CurBank = ybank(pixely)
                END IF
                Ycounter = Ycounter + ystep
                WHILE Ycounter >= 0
                        Ycounter = Ycounter - scrysize: chbyteptr = chbyteptr + 1
                        IF lyptr <> chbyteptr THEN
                                DEF SEG = Fontseg
                                FOR strptr = 1 TO LEN(t$)
                                  ta(strptr) = PEEK(t1a&(strptr) + chbyteptr)
                                NEXT
                                lyptr = chbyteptr
                        END IF
                WEND
                DEF SEG = yseg(pixely)
                FOR strptr = 1 TO LEN(t$)
                        chbitptr = 7: XCounter = -scrxsize
                        x = x1
                        FOR x = oa&(strptr) TO ea&(strptr) STEP vesainfo.bytespixel
                                IF (ta(strptr) AND PwrsOf2(chbitptr)) THEN
                                    SELECT CASE vesainfo.bpp
                                    CASE 32, 24
                                        POKE x + 2, R
                                        POKE x + 1, g
                                        POKE x, b
                                    CASE 15, 16
                                        a = rlook(R) OR g2look(g)
                                        a1 = glook(g) OR blook(b)
                                        POKE x, a1: POKE x + 1, a
                                    CASE 8
                                        POKE x, rlook(R) + glook(g) + blook(b)
                                    CASE ELSE
                                    END SELECT
                                END IF
                                XCounter = XCounter + xstep
                                WHILE XCounter >= 0
                                        XCounter = XCounter - scrxsize: chbitptr = chbitptr - 1
                                WEND
                        NEXT
                NEXT
        NEXT
        ERASE t1a&, ta, oa&, ea&
END SUB

SUB SVGAPutBlock (xi, yi, dx, dy)
SHARED vesainfo AS vesainfoblock
SHARED rlook(), glook(), blook(), g2look()
SHARED yseg(), ybank()
SHARED xoff()
SHARED CurBank AS INTEGER
SHARED rgb() AS INTEGER
SHARED Regs AS regtypeX

FOR y = 0 TO dy
  y1 = yi + y
  IF y1 >= vesainfo.yres THEN EXIT SUB
 
  'switch bank if needed
  IF ybank(y1) <> CurBank THEN
    CurBank = ybank(y1)
    Regs.ax = &H4F05
    Regs.bx = 0
    Regs.dx = CurBank
    CALL INTERRUPTy(&H10, Regs)
  END IF
  DEF SEG = yseg(y1)
 
  FOR x = 0 TO dx
    x1 = xi + x
    IF x1 >= vesainfo.xres THEN EXIT FOR
    Offset = xoff(x1)
    'put pixel
    R = rgb(0, x, y)
    g = rgb(1, x, y)
    b = rgb(2, x, y)
    SELECT CASE vesainfo.bpp
    'truecolor (24 bits not supported)
    CASE 32, 24
        POKE Offset + 2, R
        POKE Offset + 1, g
        POKE Offset, b
    'hicolor
    CASE 15, 16
        a = rlook(R) OR g2look(g)
        a1 = glook(g) OR blook(b)
        POKE Offset, a1: POKE Offset + 1, a
 
    'paletted modes use a very unaccurate dithering.
    'error is carried thru all block and then carried to top of next block
    'i should use an array...
    CASE 8
      POKE Offset, rlook(R + re1) + glook(g + ge1) + blook(b + be1)
      re1 = g2look(R + re1): ge1 = g2look(g + ge1): be1 = g2look(b + be1)

    CASE ELSE
    END SELECT
   NEXT
  NEXT
EXIT SUB
'2 Offset& = xBpp&(x%) + yLut(y%).Offset
'Bank% = yLut(y%).Bank%

IF Offset& > Ww THEN
  Offset& = Offset& AND Ww
  Bank% = Bank% + 1
END IF

IF Bank% <> CurBank% THEN
  CurBank% = Bank%
  Regs.ax = &H4F05
  Regs.bx = 0
  Regs.dx = CurBank%
  CALL INTERRUPT(&H10, Regs, Regs)
END IF
POKE Offset&, Blue%

Offset& = Offset& + 1
IF Offset& > Ww THEN
  Offset& = Offset& AND Ww
  CurBank% = CurBank% + 1
  Regs.ax = &H4F05
  Regs.bx = 0
  Regs.dx = CurBank%
  CALL INTERRUPT(&H10, Regs, Regs)
END IF
POKE Offset&, Green%

Offset& = Offset& + 1
IF Offset& >= Ww THEN
  Offset& = Offset& AND Ww
  CurBank% = CurBank% + 1
  Regs.ax = &H4F05
  Regs.bx = 0
  Regs.dx = CurBank%
  CALL INTERRUPT(&H10, Regs, Regs)
END IF
POKE Offset&, Red%



END SUB

SUB SVGAPutBlockBW (xi, yi, dx, dy)

SHARED vesainfo AS vesainfoblock
SHARED yseg(), ybank()
SHARED xoff()
SHARED CurBank AS INTEGER
SHARED rgb() AS INTEGER
SHARED Regs AS regtypeX

FOR y = 0 TO dy
  y1 = yi + y
  IF y1 >= vesainfo.yres THEN EXIT SUB

  'switch bank if needed
  IF ybank(y1) <> CurBank THEN
    CurBank = ybank(y1)
    Regs.ax = &H4F05
    Regs.bx = 0
    Regs.dx = CurBank
    CALL INTERRUPTy(&H10, Regs)
  END IF
  DEF SEG = yseg(y1)

  FOR x = 0 TO dx
    x1 = xi + x
    IF x1 >= vesainfo.xres THEN EXIT FOR
    Offset = xoff(x1)
    'put pixel
    POKE Offset, rgb(0, x, y)
  NEXT
NEXT

END SUB

FUNCTION SVGASelectMode%

'menu allowing user to select a SVGA mode.
'only modes allowing optimal line length ar proposed.
'For B/W images, only 8 bits modes are proposed.
'Added mode sorting by resolution

SHARED f$
SHARED vesainfo AS vesainfoblock
SHARED display AS vesaModeinfoBlock
SHARED jpeg AS JpegType
SHARED modes() AS VESAsorttype
'create an array to contain all the menu lines
REDIM modes(0 TO vesainfo.modemax) AS VESAsorttype

'formatting strings

CONST FRMT2$ = "## \                                \"

  'check all available modes, discard Text and 4bitplane modes
  x = 1
  ptr1 = vesainfo.VIDEOMODEPTR
  FOR i = 1 TO vesainfo.modemax
    'get the mode numbers string location
    ii = 2 * i - 2
    'each mode nr is two bytes in the mode string
    DEF SEG = vesainfo.VIDEOMODESEG
    md& = PEEK(ptr1 + ii + 1) * 256& + PEEK(ptr1 + ii)
    DEF SEG
    'get info about current mode
    SVGAGetModeInfo (md&)
    'if mode can be set then retain only 8bit paletted and true-hi color
    IF display.Modeattributes AND 1 THEN
      SELECT CASE ASC(display.MemoryModel)
      CASE 4       '8 bit PALETTED MODE
         svgacheckmode x, md&
      CASE 6       'TRUE/HIGH COLOR MODE
        IF jpeg.numcomp > 1 THEN   'no color modes for monochrome images
         svgacheckmode x, md&
        END IF
      CASE ELSE
      END SELECT
    END IF
  NEXT
  x = x - 1
  COLOR 15, 0

  'sort mode description array entries
  FOR i = 2 TO x
    j = i
    DO
      IF modes(j).INDEX < modes(j - 1).INDEX THEN
       SWAP modes(j), modes(j - 1)
       j = j - 1
      ELSE
       EXIT DO
      END IF
    LOOP
  NEXT
 
  CLS
  'display modes menu
  PRINT "The file "; f$; " is "; jpeg.cols; " X "; jpeg.rows
  PRINT
  PRINT "Available VESA modes. * signals those displaying the whole picture "
  COLOR 12, 0
  PRINT "If your monitor behaves strangely ";
  COLOR 15, 4: PRINT "PRESS ESCAPE";
  COLOR 12, 0: PRINT " key inmediately!!      "
  COLOR 7, 0
  PRINT
  c1 = 15: C2 = 7
  FOR i = 1 TO x
    IF (modes(i).INDEX \ 100) <> LI& THEN COLOR c1: LI& = modes(i).INDEX \ 100: SWAP c1, C2
    LOCATE , 22: PRINT USING FRMT2$; i; modes(i).CAPTION
  NEXT
  'get user input and go set SVGA mode
  DO: LOCATE , 22: INPUT "Select a mode: ", k: LOOP UNTIL k > 0 AND k <= x
  md = modes(k).MODE
  ERASE modes
  fail = SVGAsetmode(md)

END FUNCTION

FUNCTION SVGAsetmode (MODE)
'Sets the VESA mode passed, selects the faster line length and
'initializes the look up tables for this mode, palette if needed.
'Optimizes line length, and sets DAC to 8 bit mode if needed
'If called with mode=3 returns to VGA textmode 50 rows.


SHARED rlook(), glook(), blook(), g2look()
SHARED xoff(), yseg(), ybank()
SHARED vesainfo AS vesainfoblock
SHARED display AS vesaModeinfoBlock
SHARED jpeg AS JpegType
SHARED Regs AS regtypeX
SHARED CurBank AS INTEGER

' Sets an SVGA mode, and saves some useful parameters

    Regs.ax = &H4F02  'Set the mode.
    Regs.bx = MODE
    CALL INTERRUPTy(&H10, Regs)
    IF Regs.ax <> &H4F THEN SVGAsetmode = 0: EXIT FUNCTION

    'if returning to text mode, do it and exit
    IF MODE = 3 THEN
        SCREEN 7: WIDTH 80, 50: CLS
        EXIT FUNCTION
    END IF

    'else fill vesainfo array
    SVGAGetModeInfo (MODE)
    vesainfo.modenum = MODE
    vesainfo.xres = display.xres
    vesainfo.yres = display.yres
    vesainfo.bpp = ASC(display.bpp)
    vesainfo.winsize = 1024& * display.winsize
    BankSpacing = display.winsize \ display.WinGranularity
    vesainfo.WINMASK = vesainfo.winsize - 1
    vesainfo.winseg = display.winAsegment
    vesainfo.bw = false
    vesainfo.numberofbanks = (vesainfo.BYTESROW * vesainfo.yres) \ vesainfo.winsize + 1
    vesainfo.charx = vesainfo.xres \ 90: IF vesainfo.charx < 4 THEN vesainfo.charx = 4
    vesainfo.chary = vesainfo.yres \ 30: IF vesainfo.chary < 5 THEN vesainfo.chary = 5


    'calculate line length to avoid bank checking for each pixel of the line
    'this won't work for 3 byte modes, these require bank checking for each byte poked!
    'so i banned 24 bit modes, if your card does'nt have 32 byte modes you will  have
    'truecolor screens.

    vesainfo.bytespixel = (vesainfo.bpp + 7) \ 8
    IF vesainfo.bytespixel = 3 THEN factor = 4096 ELSE factor = 128
    a = 1
    a1 = vesainfo.bytespixel * vesainfo.xres

    'calculate the next power of two
    DO UNTIL a * factor >= a1
        a = a * 2
    LOOP
    linelen& = a * factor / vesainfo.bytespixel

    Regs.ax = &H4F06  'Set optimal line length
    Regs.bx = 0
    Regs.dx = 0
    Regs.cx = linelen&
    CALL INTERRUPTy(&H10, Regs)
    'if optimal line length can't be set, error
    IF Regs.cx <> linelen& THEN Setsvgamode = 0: END
    vesainfo.BYTESROW = linelen& * vesainfo.bytespixel

    'set DAC to 8 bits, if available. Must be renewed for each mode change
    IF vesainfo.capabilities AND 1& THEN
        Regs.ax = &H4F08  'Program DAC width to 8 bits
        Regs.bx = 0
        CALL INTERRUPTy(&H10, Regs)
    END IF
   
    SVGAsetmode = 1

    'Create palettes for the 8 bits modes

    IF (vesainfo.bytespixel = 1) AND (jpeg.numcomp > 1) THEN
      'create approximative color palette 6x6x6
      PI = 4
      OUT &H3C8, PI
      FOR R! = 0 TO 63 STEP 62 \ 5
        FOR g! = 0 TO 63 STEP 62 \ 5
           FOR b! = 0 TO 63 STEP 62 \ 5
             OUT &H3C9, CINT(R!)
             OUT &H3C9, CINT(g!)
             OUT &H3C9, CINT(b!)
             PI = PI + 1
           NEXT
        NEXT
      NEXT
   
    'create the greyscale palette 
    ELSEIF jpeg.numcomp = 1 THEN
      vesainfo.bw = true
      
      OUT &H3C8, 0
      FOR i1 = 0 TO 255
       temp = i1 \ 4
       OUT &H3C9, temp
       OUT &H3C9, temp
       OUT &H3C9, temp
      NEXT
    END IF

    'make color lookup tables, they will save calculations at rendering
    SELECT CASE vesainfo.bpp
    CASE 16
      FOR i% = 0 TO 255
        blook(i%) = i% \ 8
        glook(i%) = (i% AND &H38) * 8
        g2look(i%) = i% \ 32
        rlook(i%) = i% AND &HF8
      NEXT
    CASE 15
      FOR i% = 0 TO 255
        blook(i%) = i% \ 8
        glook(i%) = (i% AND &H38) * 4
        g2look(i%) = i% \ 64
        rlook(i%) = (i% \ 2) AND &H7C
      NEXT
    CASE 8
      k! = 5 / 256
      FOR i = l1 TO l2
          blook(i) = CINT(i * k!) + 4
          glook(i) = CINT(i * k!) * 6
          rlook(i) = CINT(i * k!) * 36
          'calculate the difference to real color for each entry, for dithering
          g2look(i) = (i - 256 / 5 * CINT(i * k!))
      NEXT
    CASE ELSE
    END SELECT

    'create line lookup tables: a table for the bank number, anothe one for offsets
   
    FOR i = 0 TO vesainfo.yres
        yseg(i) = &HA000 + ((i * vesainfo.BYTESROW) AND vesainfo.WINMASK) \ 16
        ybank(i) = (i * CLNG(vesainfo.BYTESROW)) \ vesainfo.winsize * BankSpacing
    NEXT

    'create a table for x offsets (it saves mults at rendering)
    FOR i = 0 TO vesainfo.xres
        xoff(i) = i * vesainfo.bytespixel
    NEXT
    CurBank = -1

END FUNCTION

